<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');

class osmaControllerChiusura extends JControllerLegacy {

    private function response($array) {
        $document = JFactory::getDocument();
        $document->setMimeEncoding('application/json');

        echo json_encode($array);
        exit;
    }

    public function getModel($name = '', $prefix = '', $config = array('ignore_request' => true)) {
        return parent::getModel($name, $prefix, $config);
    }

    public function salvaChiusura() {
        $db = JFactory::getDbo();
        $form = JRequest::get("POST");
        $valid = true;
        $message = array();
        $script = array();
        $array = array('fineLavori', 'equipment');

        foreach ($array as $v) {
            if (!trim($form[$v])) {
                $valid = false;
                $message[] = 'Attenzione: compilare tutti i campi necessari';
                break;
            }
        }

        if ($form['tipo'] != 1) {
            if (!$form['rischio']) {
                $valid = false;
                $message[] = 'Selezionare il rischio accettabile con prenotazione';
            }
            if ($form['rischio'] == 5 && trim($form['altreRischio']) == "") {
                $valid = false;
                $message[] = 'Compilare il testo "Altro" del campo 3a';
                $script[] = "$('[name=altreRischio]').addClass('invalid');";
            }
            if (!$form['precauzioni']) {
                $valid = false;
                $message[] = 'Selezionare le precauzioni a carico del gestore del p.to vendita';
            }
            if ($form['precauzioni'] == 4 && trim($form['altrePrecauzioni']) == "") {
                $valid = false;
                $message[] = 'Compilare il testo "Altro" del campo 3b';
                $script[] = "$('[name=altrePrecauzioni]').addClass('invalid');";
            }

            if ($form['tipo'] == 3) {
                if ($form['ragionisociali']) {
                    foreach ($form['ragionisociali'] as $c => $v) {
                        if ($v && !$form['signature' . ($c + 2)]) {
                            $valid = false;
                            $message[] = 'Firmare il documento nella sezione "FIRMA LAVORO / IMPRESA #' . ($c + 2) . '"';
                        }
                    }
                }
                if ($form['signature2'] && !$form['ragionisociali'][0]) {
                    $valid = false;
                    $message[] = 'Compilare la ragione sociale del lavoro / impresa #2';
                }
                if ($form['signature3'] && !$form['ragionisociali'][1]) {
                    $valid = false;
                    $message[] = 'Compilare la ragione sociale del lavoro / impresa #3';
                }
                if ($form['signature4'] && !$form['ragionisociali'][2]) {
                    $valid = false;
                    $message[] = 'Compilare la ragione sociale del lavoro / impresa #4';
                }
            }
        }
        if (!$form['signaturePtoVendita']) {
            $valid = false;
            $message[] = 'Firmare il documento nella sezione "Gestore del p.to vendita"';
        }
        if (!$form['signature1']) {
            $valid = false;
            $message[] = 'Firmare il documento nella sezione "FIRMA LAVORO / IMPRESA #1"';
        }

        if (!$valid) {
            $script[] = "alert('" . implode("\\r", $message) . "');";
        }

        if ($form['fineLavori']) {
            $ex = explode(" ", $form['fineLavori']);
            $ex2 = explode("/", $ex[0]);
            $form['fineLavori'] = "{$ex2[2]}/{$ex2[1]}/{$ex2[0]} {$ex[1]}";
        }

        if ($form['dataRevisione']) {
            $ex = explode(" ", $form['dataRevisione']);
            $ex2 = explode("/", $ex[0]);
            $form['dataRevisione'] = "{$ex2[2]}/{$ex2[1]}/{$ex2[0]} {$ex[1]}";
        }

        if ($valid) {
            $data = new stdClass();
            $data->idIntervento = $form['idIntervento'];
            $data->fineLavori = date("Y-m-d H:i:s", strtotime($form['fineLavori']));
            $data->equipment = $form['equipment'];
            $data->tipo = $form['tipo'];
            $data->rischio = $form['rischio'];
            $data->altreRischio = $form['altreRischio'];
            $data->precauzioni = $form['precauzioni'];
            $data->altrePrecauzioni = $form['altrePrecauzioni'];
            $data->statoRevisione = $form['statoRevisione'];
            $data->revisionNumber = $form['revisionNumber'];
            $data->dataRevisione = date("Y-m-d H:i:s", strtotime($form['dataRevisione']));
            $data->signaturePtoVendita = $form['signaturePtoVendita'];

            if ($form['ragionisociali']) {
                foreach ($form['ragionisociali'] as $k => $v) {
                    if (!$v) {
                        unset($form['ragionisociali'][$k]);
                    }
                }
            }

            $data->ragionisociali = serialize($form['ragionisociali']);

            $data->signature1 = $form['signature1'];
            $data->signature2 = $form['signature2'];
            $data->signature3 = $form['signature3'];
            $data->signature4 = $form['signature4'];

            if ($form['idDuvri']) {
                $data->id = $form['idDuvri'];
                $db->updateObject('#__osma_duvri', $data, 'id');
                $script[] = "
                $(\"html, body\").animate({ scrollTop: $('ul.nav.nav-tabs').offset().top }, 1000, function(){
                    $(\"ul.nav.nav-tabs [href='#duvri']\").parent().addClass('disabled');
                    $(\"ul.nav.nav-tabs [href='#registro']\").parent().removeClass('disabled hidden').find('a').trigger('click');
                });";
            } elseif ($db->insertObject('#__osma_duvri', $data)) {
                $script[] = "
                $(\"[name=idDuvri]\").val(" . $db->insertid() . ");
                $(\"html, body\").animate({ scrollTop: $('ul.nav.nav-tabs').offset().top }, 1000, function(){
                    $(\"ul.nav.nav-tabs [href='#duvri']\").parent().addClass('disabled');
                    $(\"ul.nav.nav-tabs [href='#registro']\").parent().removeClass('disabled hidden').find('a').trigger('click');
                });";
            }
        }

        self::response(array(
            'response' => $valid,
            'message' => implode("\r\n", $message),
            'script' => implode("", $script),
        ));
    }

    public function salvaRapporto() {

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $form = JRequest::get("POST");
        $valid = true;
        $message = array();
        $script = array();
        $user = JFactory::getUser();

        $rapporto = new stdClass();

        $rapporto->idDuvri = $form['idDuvri'];
        $rapporto->tipoRapporto = $form['tipoRapporto'];
        $rapporto->tipoIntervento = $form['tipoIntervento'];
        $rapporto->oraI = date("Y-m-d {$form['orai']}:{$form['minutoi']}:00");
        $rapporto->oraF = date("Y-m-d {$form['oraf']}:{$form['minutof']}:00");
        $rapporto->descrizione = $form['descrizione'];
        $rapporto->materialeImpiegato = $form['materialeImpiegato'];
        $rapporto->firma1 = $form['firma1'];
        $rapporto->firma2 = $form['firma2'];
        $rapporto->firma3 = $form['firma3'];

        list($dataIntervento['d'], $dataIntervento['m'], $dataIntervento['y']) = explode("/", $form['dataIntervento']);
        $rapporto->dataIntervento = date("Y-m-d H:i:s", mktime(0, 0, 0, $dataIntervento['m'], $dataIntervento['d'], $dataIntervento['y']));

        switch ($rapporto->tipoRapporto) {
            case 1:
                $rapporto->firma3 = $rapporto->firma1;
                if (!$rapporto->firma1 || !$rapporto->firma2 || !$rapporto->firma3) {
                    $valid = false;
                    $message[] = 'Firmare il documento in tutte le sue parti';
                }
                break;
        }

        $rapporto->osservazioni = $form['osservazioni'];

        $arrayBoolean = array('esitoCollaudo', 'dichiarazione1', 'dichiarazione2', 'dichiarazione3', 'registro1', 'registro2', 'registro3', 'registro4');
        foreach ($arrayBoolean as $val) {
            if (isset($form[$val])) {
                $rapporto->$val = $form[$val];
            } else {
                $rapporto->$val = null;
            }
        }

        $rapporto->partenzaDa = $form['partenzaDa'];
        $rapporto->partenzaOre = $form['partenzaOre']['h'] . ":" . $form['partenzaOre']['m'];
        $rapporto->arrivo = $form['arrivo'];
        $rapporto->arrivoOre = $form['arrivoOre']['h'] . ":" . $form['arrivoOre']['m'];
        $rapporto->oreLavoro = $form['oreLavoro'];
        $rapporto->percorrenzaAndata = $form['percorrenzaAndata'];
        $rapporto->percorrenzaRitorno = $form['percorrenzaRitorno'];
        $rapporto->kmAndata = $form['kmAndata'];
        $rapporto->kmRitorno = $form['kmRitorno'];

        $rapporto->firmaArray = array();
        foreach ($form as $k => $v) {
            if (strpos($k, 'firmaArray-') !== false) {
                $rapporto->firmaArray[] = array('id' => str_replace('firmaArray-', '', $k), 'firma' => $v);
            }
        }
        $rapporto->firmaArray = serialize($rapporto->firmaArray);

        if ($valid) {

            if ($form['idRapporto']) {
                $rapporto->idRapporto = $form['idRapporto'];
                $db->updateObject('#__osma_duvri_rapporto', $rapporto, 'idRapporto', true);
            } else {
                $db->insertObject('#__osma_duvri_rapporto', $rapporto, 'idRapporto', true);
                $rapporto->idRapporto = $db->insertid();
            }

            $query->delete($db->qn('#__osma_duvri_rapporto_distributori'));
            $query->where($db->qn('idRapporto') . '=' . $db->q($rapporto->idRapporto));
            $db->setQuery($query);
            $db->query();
            $query->clear();

            $query->delete($db->qn('#__osma_duvri_rapporto_pagamenti'));
            $query->where($db->qn('idRapporto') . '=' . $db->q($rapporto->idRapporto));
            $db->setQuery($query);
            $db->query();
            $query->clear();

            $query->delete($db->qn('#__osma_duvri_rapporto_materiale'));
            $query->where($db->qn('idRapporto') . '=' . $db->q($rapporto->idRapporto));
            $db->setQuery($query);
            $db->query();

            if ($form['pt']) {
                foreach ($form['pt'] as $ptN) {
                    if (!$ptN['matricola'])
                        continue;
                    $pt = new stdClass();
                    $pt->idRapporto = $rapporto->idRapporto;
                    $pt->idMatricola = $ptN['matricola'];
                    $pt->letturePrima = $ptN['lprima'];
                    $pt->lettureDopo = $ptN['ldopo'];
                    $pt->piombi = $ptN['piombi'];
                    $pt->taratura = $ptN['taratura'];
                    $pt->scostamento = $ptN['scostamento'];
                    $pt->v = $ptN['v'];
                    $pt->l = $ptN['l'];
                    $pt->descrizione = $ptN['descrizione'];
                    $pt->sA = $ptN['sA'];
                    $pt->sPA = $ptN['sPA'];
                    $pt->aP = $ptN['aP'];

                    $db->insertObject('#__osma_duvri_rapporto_distributori', $pt, 'id', false);
                }
            }

            if ($form['cc']) {
                foreach ($form['cc'] as $ptN) {
                    if (!$ptN['matricola'])
                        continue;
                    $pt = new stdClass();
                    $pt->idRapporto = $rapporto->idRapporto;
                    $pt->idMatricola = $ptN['matricola'];
                    $pt->piombi = $ptN['piombi'];
                    $pt->postPagamento = 0;

                    $db->insertObject('#__osma_duvri_rapporto_pagamenti', $pt, 'id', false);
                }
            }

            if ($form['ss']) {
                foreach ($form['ss'] as $ptN) {
                    if (!$ptN['matricola'])
                        continue;
                    $pt = new stdClass();
                    $pt->idRapporto = $rapporto->idRapporto;
                    $pt->idMatricola = $ptN['matricola'];
                    $pt->piombi = $ptN['piombi'];
                    $pt->postPagamento = 1;

                    $db->insertObject('#__osma_duvri_rapporto_pagamenti', $pt, 'id', false);
                }
            }

            if ($form['ms']) {
                foreach ($form['ms'] as $ptN) {
                    $pt = new stdClass();
                    $pt->idRapporto = $rapporto->idRapporto;
                    $pt->quantita1 = $ptN['quantita1'];
                    $pt->quantita2 = $ptN['quantita2'];
                    $pt->fornitura1 = $ptN['fornitura1'];
                    $pt->fornitura2 = $ptN['fornitura2'];
                    $pt->ac = $ptN['ac'];

                    $db->insertObject('#__osma_duvri_rapporto_materiale', $pt, 'id', false);
                }
            }

            if ($form['librettoMetrologico'] && $form['generaLibretti']) {
                $pistole = array();
                $matricole = array();
                foreach ($form['generaLibretti'] as $idPistola) {

                    $idMatricola = $db->setQuery("SELECT idMatricola FROM #__osma_anagrafica_pistole WHERE idPistola = {$idPistola}")->loadResult();
                    $pistole[$idMatricola][] = $idPistola;
                    $matricole[] = $idMatricola;
                }

                foreach ($matricole as $idMatricola) {

                    $libretto = new stdClass();
                    $libretto->idIntervento = $form['idIntervento'];
                    $libretto->idMatricola = $idMatricola;
                    $libretto->idPistole = serialize($pistole[$idMatricola]);
                    $libretto->idUser = $user->id;
                    $libretto->librettoMetrologico = "";

                    $db->setQuery("DELETE FROM #__osma_rapporto_libretti_metrologici WHERE idMatricola = {$libretto->idMatricola} AND idIntervento = {$libretto->idIntervento} AND idUser = {$libretto->idUser}")->execute();

                    $db->insertObject("#__osma_rapporto_libretti_metrologici", $libretto, "idLibretto");

                    $libretto->idLibretto = $db->insertid();
                    $libretto->librettoMetrologico = self::creaLibretto($libretto);
                    $db->updateObject("#__osma_rapporto_libretti_metrologici", $libretto, 'idLibretto');

                    $hasLibretto[] = $libretto->idLibretto;
                }
            }

            if ($form['creazioneCheckList'] && $form['checklist']) {
                $obj = new stdClass();
                $obj->idIntervento = $form['idIntervento'];
                $obj->idUser = $user->id;
                $obj->matricolaDistributore = $form['checklist']['matricolaD'];
                $obj->matricolaSSD = $form['checklist']['matricolaSS'];
                $obj->checks = serialize($form['checklist']['checks']);

                $db->insertObject("#__osma_checklist", $obj, "idChecklist");

                $hasChecklist = $db->insertid();
            }

            if ($form['statoIntervento']) {

                $intervento = new stdClass();
                $intervento->idIntervento = $form['idIntervento'];
                $intervento->statoIntervento = $form['statoIntervento'];
                $intervento->noteCambioStato = $form['noteCambioStato'];

                $intervento->cambioStato = date("Y-m-d H:i:s");
                $intervento->rimozionePiombi = JRequest::getVar('rimozionePiombi');
                $db->updateObject('#__osma_chiamata_interventi', $intervento, 'idIntervento', false);



                $query = "SELECT i.*, c.*, d.id as idDuvri, r.idRapporto, g.nrRea  "
                        . "FROM #__osma_chiamata_interventi i "
                        . "INNER JOIN #__osma_chiamate c ON c.idChiamata = i.idChiamata "
                        . "INNER JOIN #__osma_anagrafica_gestori g ON c.idGestore = g.idGestore "
                        . "LEFT OUTER JOIN #__osma_duvri d ON d.idIntervento = i.idIntervento "
                        . "LEFT OUTER JOIN #__osma_duvri_rapporto r ON d.id = r.idDuvri "
                        . "WHERE i.idIntervento = {$intervento->idIntervento}";
                $db->setQuery($query);
                $result = $db->loadObject();

                if ($intervento->statoIntervento == 2) {
                    $query = "
                INSERT  INTO #__osma_chiamata_interventi (idChiamata, idTipoIntervento, idInviaMailA, idMezzo, note, idMezzo2, idInterventoRiferimento)
                SELECT  idChiamata, idTipoIntervento, idInviaMailA, idMezzo, note, idMezzo2, {$intervento->idIntervento}
                FROM    #__osma_chiamata_interventi
                WHERE   idIntervento = {$intervento->idIntervento}";
                    $db->setQuery($query);
                    $db->execute();

                    $to[] = "osmasnc@osmasnc.it";
                    $to[] = "osmasnc.mariotti@osmasnc.it";

                    $body = "<p>Intervento <b>#{$intervento->idIntervento}</b>, relativo alla chiamata #{$result->nrChiamata}, sospeso in data " . date("d/m/Y H:i") . ".</p>";
                    $body .= "<p><b>Motivo della sospensione:</b> {$form['noteCambioStato']}</p>";
                    $subject = "Sospensione intervento #{$intervento->idIntervento}";
                } elseif ($intervento->statoIntervento == 1) {
                    $query = "SELECT COUNT(*) FROM #__osma_chiamata_interventi WHERE idChiamata = {$form['idChiamata']} AND statoIntervento != 1";
                    $db->setQuery($query);

                    if ($db->loadResult() == 0) {
                        $query = "UPDATE #__osma_chiamate SET stato = 4 WHERE idChiamata = {$form['idChiamata']}";

                        $db->setQuery($query);
                        $db->execute();
                    }
                    $to[] = "osmasnc@osmasnc.it";

                    $body = "<p>Intervento <b>#{$intervento->idIntervento}</b>, relativo alla chiamata #<b>{$result->nrChiamata}</b>, chiuso in data " . date("d/m/Y H:i") . ".</p>";
                    $subject = "Chiusura intervento #{$intervento->idIntervento}";
                }

                $query = "SELECT g.*,c.compagnia,c.fascia,cont.riferimento,cont.telefono
            FROM #__osma_anagrafica_gestori AS g
            LEFT JOIN #__osma_anagrafica_compagnie AS c ON g.idCompagnia=c.idCompagnia
            LEFT JOIN #__osma_gestori_contatti AS cont ON cont.idGestore=g.idGestore
            WHERE g.idGestore=" . $result->idGestore;

                $db->setQuery($query);
                $datiMail = $db->loadObject();
                $subject .= " // #{$result->nrChiamata} // " . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ") // " . $user->name;

                $body .= "<hr>";
                $body .= "<p><strong>Compagnia:</strong> " . $datiMail->compagnia . "</p>";
                $body .= "<p><strong>Codice Compagnia:</strong> " . $result->nrChiamataCompagnia . "</p>";
                $body .= "<p><strong>Impianto:</strong> " . $datiMail->nrPuntoVendita . "</p>";
                $body .= "<p><strong>Dati Impianto:</strong> " . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ")</p>";
                $body .= "<p><strong>Vedi mappa:</strong><a href='https://www.google.it/maps/dir/" . $datiMail->indirizzo . " " . $datiMail->comune . " " . $datiMail->provincia . "' target='_blank'>Clicca qui</a></p>";
                $body .= "<p><strong>Gruppo:</strong> " . $datiMail->fascia . "</p>";
                $body .= "<p><strong>Gestore:</strong> " . $datiMail->riferimento . "</p>";
                $body .= "<p><strong>Telefono:</strong> " . $datiMail->telefono . "</p>";
                $body .= "<p><strong>Data/Ora Chiamata:</strong> " . date("d/m/Y H:i", strtotime(str_replace("/", "-", $result->dataApertura))) . "</p>";
                $body .= "<p><strong>Data/Ora Scadenza:</strong> " . date("d/m/Y H:i", strtotime(str_replace("/", "-", $result->dataScadenza))) . "</p>";

                $body .= "<br/><br/><p>Visualizza l'intervento a questo <a href='" . JURI::root() . "/index.php?option=com_osma&view=chiamata&idChiamata={$result->idChiamata}&idIntervento={$intervento->idIntervento}'>link</a>";


                $mailer = JFactory::getMailer();
                $mailer->setSender(array($user->email, $user->name));

                if (JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug") && JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address")) {
                    $mailer->addCC(JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address"));
                }

                $mailer->addRecipient($to);
                $mailer->setSubject($subject);
                $mailer->isHTML(true);
                $mailer->Encoding = 'base64';
                $mailer->setBody($body);

                if ($rapporto->idRapporto) {
                    $query = "SELECT idDuvri FROM #__osma_duvri_rapporto WHERE idRapporto = {$rapporto->idRapporto}";


                    $db->setQuery($query);
                    $idDUVRI = $db->loadResult();

                    $duvri = $this->visualizzaPDFduvri($idDUVRI);
                    $rapporto = $this->visualizzaPDFrapporto($rapporto->idRapporto, $form['idChiamata']);

                    if ($duvri) {
                        $mailer->addAttachment($duvri, JApplication::stringURLSafe("chiamata {$result->idChiamata} - intervento {$intervento->idIntervento} - DUVRI") . ".pdf");
                    }
                    if ($rapporto) {
                        $mailer->addAttachment($rapporto, JApplication::stringURLSafe("chiamata {$result->idChiamata} - intervento {$intervento->idIntervento} - RDL") . ".pdf");
                    }
                }
                mailerHelper::logMail($mailer, 4, $mailer->Send(), $intervento->idChiamata);


                if (JRequest::getVar('rimozionePiombi')) {

                    $mailer = JFactory::getMailer();
                    $mailer->setSender(array($user->email, $user->name));
                    $to[] = "osmasnc@osmasnc.it";

                    if (JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug") && JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address")) {
                        $mailer->addCC(JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address"));
                    }

                    $subject = "Rimozione piombi per intervento #" . JRequest::getVar('idIntervento') . " // #{$result->nrChiamata} // " . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ") // " . $user->name;

                    $body = "<b>ATTENZIONE</b>: rimozione piombi per intervento #" . JRequest::getVar('idIntervento');
                    $body .= "<hr>";
                    $body .= "<p><strong>Compagnia:</strong> " . $datiMail->compagnia . "</p>";
                    $body .= "<p><strong>Codice Compagnia:</strong> " . $result->nrChiamataCompagnia . "</p>";
                    $body .= "<p><strong>Impianto:</strong> " . $datiMail->nrPuntoVendita . "</p>";
                    $body .= "<p><strong>Dati Impianto:</strong> " . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ")</p>";
                    $body .= "<p><strong>Vedi mappa:</strong><a href='https://www.google.it/maps/dir/" . $datiMail->indirizzo . " " . $datiMail->comune . " " . $datiMail->provincia . "' target='_blank'>Clicca qui</a></p>";
                    $body .= "<p><strong>Gruppo:</strong> " . $datiMail->fascia . "</p>";
                    $body .= "<p><strong>Gestore:</strong> " . $datiMail->riferimento . "</p>";
                    $body .= "<p><strong>Telefono:</strong> " . $datiMail->telefono . "</p>";
                    $body .= "<p><strong>Data/Ora Chiamata:</strong> " . date("d/m/Y H:i", strtotime(str_replace("/", "-", $result->dataApertura))) . "</p>";
                    $body .= "<p><strong>Data/Ora Scadenza:</strong> " . date("d/m/Y H:i", strtotime(str_replace("/", "-", $result->dataScadenza))) . "</p>";
                    $body .= "<br/><br/><p>Visualizza l'intervento a questo <a href='" . osmaHelper::router("index.php?option=com_osma&view=chiamata&idChiamata={$result->idChiamata}&idIntervento={$intervento->idIntervento}", true) . "'>link</a>";

                    $mailer->addRecipient($to);
                    $mailer->setSubject($subject);
                    $mailer->isHTML(true);
                    $mailer->Encoding = 'base64';
                    $mailer->setBody($body);

                    mailerHelper::logMail($mailer, 5, $mailer->Send(), $intervento->idChiamata);
                }

                if ($hasChecklist) {
                    $mailer = JFactory::getMailer();
                    $mailer->setSender(array($user->email, $user->name));
                    $to[] = "osmasnc@osmasnc.it";

                    if (JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug") && JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address")) {
                        $mailer->addCC(JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address"));
                    }

                    $subject = "Checklist per intervento #" . JRequest::getVar('idIntervento') . " // #{$result->nrChiamata} // " . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ") // " . $user->name;

                    $body = "<b>In allegato</b>: checklist per l'intervento #" . JRequest::getVar('idIntervento');
                    $body .= "<hr>";
                    $body .= "<p><strong>Compagnia:</strong> " . $datiMail->compagnia . "</p>";
                    $body .= "<p><strong>Codice Compagnia:</strong> " . $result->nrChiamataCompagnia . "</p>";
                    $body .= "<p><strong>Impianto:</strong> " . $datiMail->nrPuntoVendita . "</p>";
                    $body .= "<p><strong>Dati Impianto:</strong> " . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ")</p>";
                    $body .= "<p><strong>Vedi mappa:</strong><a href='https://www.google.it/maps/dir/" . $datiMail->indirizzo . " " . $datiMail->comune . " " . $datiMail->provincia . "' target='_blank'>Clicca qui</a></p>";
                    $body .= "<p><strong>Gruppo:</strong> " . $datiMail->fascia . "</p>";
                    $body .= "<p><strong>Gestore:</strong> " . $datiMail->riferimento . "</p>";
                    $body .= "<p><strong>Telefono:</strong> " . $datiMail->telefono . "</p>";
                    $body .= "<br/><br/><p>Visualizza l'intervento a questo <a href='" . osmaHelper::router("index.php?option=com_osma&view=chiamata&idChiamata={$result->idChiamata}&idIntervento={$intervento->idIntervento}", true) . "'>link</a>";

                    $temp = uniqid() . ".pdf";
                    if (!is_dir(JPATH_COMPONENT . "/tmp/")) {
                        mkdir(JPATH_COMPONENT . "/tmp/");
                    }

                    file_put_contents(JPATH_COMPONENT . "/tmp/" . $temp, file_get_contents(JUri::base() . "index.php?option=com_osma&task=chiusura.visualizzaChecklist&format=raw&idChecklist={$hasChecklist}"));

                    $mailer->addAttachment(JPATH_COMPONENT . "/tmp/" . $temp, "Checklist nr. {$hasChecklist}.pdf");

                    $mailer->addRecipient($to);
                    $mailer->setSubject($subject);
                    $mailer->isHTML(true);
                    $mailer->Encoding = 'base64';
                    $mailer->setBody($body);

                    mailerHelper::logMail($mailer, 8, $mailer->Send(), $intervento->idChiamata);
                }

                if ($hasLibretto) {
                    $mailer = JFactory::getMailer();
                    $mailer->setSender(array($user->email, $user->name));
                    $to[] = "osmasnc@osmasnc.it";

                    if (JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug") && JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address")) {
                        $mailer->addCC(JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address"));
                    }

                    if (count($hasLibretto) > 1) {
                        $subject = "Libretti metrologici creati per l'intervento #" . JRequest::getVar('idIntervento') . " // #{$result->nrChiamata} // " . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ") // " . $user->name;
                    } else {
                        $subject = "Libretto metrologico creato per l'intervento #" . JRequest::getVar('idIntervento') . " // #{$result->nrChiamata} // " . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ") // " . $user->name;
                    }

                    $body = "<b>In allegato</b>: checklist per l'intervento #" . JRequest::getVar('idIntervento');
                    $body .= "<hr>";
                    $body .= "<p><strong>Compagnia:</strong> " . $datiMail->compagnia . "</p>";
                    $body .= "<p><strong>Codice Compagnia:</strong> " . $result->nrChiamataCompagnia . "</p>";
                    $body .= "<p><strong>Impianto:</strong> " . $datiMail->nrPuntoVendita . "</p>";
                    $body .= "<p><strong>Dati Impianto:</strong> " . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ")</p>";
                    $body .= "<p><strong>Vedi mappa:</strong><a href='https://www.google.it/maps/dir/" . $datiMail->indirizzo . " " . $datiMail->comune . " " . $datiMail->provincia . "' target='_blank'>Clicca qui</a></p>";
                    $body .= "<p><strong>Gruppo:</strong> " . $datiMail->fascia . "</p>";
                    $body .= "<p><strong>Gestore:</strong> " . $datiMail->riferimento . "</p>";
                    $body .= "<p><strong>Telefono:</strong> " . $datiMail->telefono . "</p>";
                    $body .= "<br/><br/><p>Visualizza l'intervento a questo <a href='" . osmaHelper::router("index.php?option=com_osma&view=chiamata&idChiamata={$result->idChiamata}&idIntervento={$intervento->idIntervento}", true) . "'>link</a>";

                    if (!is_dir(JPATH_COMPONENT . "/tmp/")) {
                        mkdir(JPATH_COMPONENT . "/tmp/");
                    }
                    foreach ($hasLibretto as $idLibretto) {
                        $temp = uniqid() . ".pdf";
                        file_put_contents(JPATH_COMPONENT . "/tmp/" . $temp, file_get_contents(JUri::base() . "index.php?option=com_osma&task=chiusura.visualizzaLibretto&format=raw&idLibretto={$idLibretto}&update=1"));

                        $mailer->addAttachment(JPATH_COMPONENT . "/tmp/" . $temp, "Libretto metrologico nr. {$idLibretto}.pdf");
                    }

                    $mailer->addRecipient($to);
                    $mailer->setSubject($subject);
                    $mailer->isHTML(true);
                    $mailer->Encoding = 'base64';
                    $mailer->setBody($body);

                    mailerHelper::logMail($mailer, 9, $mailer->Send(), $intervento->idChiamata);
                }
            }
        }

        if ($valid) {
            $script[] = "window.location.reload();";
        } else {
            $script[] = "alert('" . implode("\\r", $message) . "');";
        }


        $filename = "intervento-{$form['idIntervento']}-rapporto-" . strtotime($rapporto->dataIntervento) . ".pdf";

        if (file_exists(JPATH_COMPONENT . "/files/chiamate/{$form['idChiamata']}/{$filename}")) {
            unlink(JPATH_COMPONENT . "/files/chiamate/{$form['idChiamata']}/{$filename}");
        }

        if ($dh = opendir(JPATH_COMPONENT . "/tmp/")) {
            while (($file = readdir($dh)) !== false) {
                if ($file == "." || $file == ".." || $file == "index.html") {
                    continue;
                }
                @unlink(JPATH_COMPONENT . "/tmp/" . $file);
            }
            closedir($dh);
        }

        self::response(array(
            'response' => $valid,
            'message' => implode("\r\n", $message),
            'script' => implode("", $script),
        ));
    }

    public function visualizzaPDFduvri($usepost = true) {
        $dbo = JFactory::getDbo();
        if ($usepost === true) {
            $idDuvri = JRequest::getVar("id");
        } else {
            $idDuvri = $usepost;
        }

        $query = $dbo->getQuery(true);
        $query->select("d.*, c.idLogo, c.dataApertura, c.nrChiamata, c.nrChiamataCompagnia, i.*, u.name")
                ->from("#__osma_duvri as d")
                ->innerJoin("#__osma_chiamata_interventi AS i ON i.idIntervento = d.idIntervento")
                ->innerJoin("#__osma_chiamate as c ON c.idChiamata = i.idChiamata")
                ->innerJoin("#__users as u ON u.id = i.idInviaMailA")
                ->where("d.id = " . $dbo->q($idDuvri));

        $dbo->setQuery($query);
        $info = $dbo->loadObject();
        $query->clear();

        $filename = "intervento-{$info->idIntervento}-duvri-" . strtotime($info->inizioLavori) . ".pdf";

        $filepath = JPATH_COMPONENT . "/files/chiamate/{$info->idChiamata}/{$filename}";
        $fileurl = JURI::root() . "/components/com_osma/files/chiamate/{$info->idChiamata}/{$filename}";

        if (!file_exists($filepath) || JRequest::getVar("update")) {

            if (!is_dir(JPATH_COMPONENT . "/files/chiamate/{$info->idChiamata}/")) {
                mkdir(JPATH_COMPONENT . "/files/chiamate/{$info->idChiamata}/");
            }

            $ragioniSociali[1] = 'OSMA';
            $ragioniSociali[2] = 'E2OIL';

            if ($info->ragionisociali) {
                $info->ragionisociali = unserialize($info->ragionisociali);
                if ($info->ragionisociali) {
                    foreach ($info->ragionisociali as $k => $data) {
                        $imprese[] = "<b>Impresa #" . ($k + 2) . ":</b> {$data}";
                    }
                    $imprese = "<br><br>" . implode("<br>", $imprese);
                }
            }

            $arrayFirme = array($info->signaturePtoVendita, $info->signature1, $info->signature2, $info->signature3, $info->signature4);
            $arrayNF = array();

            foreach ($arrayFirme as $firma) {
                if ($firma) {
                    $base64 = explode(',', $firma);
                    $base64d = base64_decode($base64[1]);
                    $im = imagecreatefromstring($base64d);
                    imagealphablending($im, false);
                    imagesavealpha($im, true);
                    $ud = uniqid();
                    if ($im !== false) {
                        imagepng($im, "$ud.png");
                        imagedestroy($im);

                        $arrayNF[] = "$ud.png";
                    }
                }
            }

            include_once JPATH_COMPONENT . "/lib/libpdf/tcpdf_include.php";

            $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
            $pdf->SetCreator(PDF_CREATOR);
            $pdf->SetFont('helvetica', '', 10);
            $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
            $pdf->SetMargins(5, 5, 5);
            $pdf->SetCellPadding(0);

            $pdf->setPrintHeader(false);
            $pdf->setPrintFooter(false);

            $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
            $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
            if (@file_exists(JPATH_COMPONENT . "/lib/libpdf/lang/ita.php")) {
                require_once(JPATH_COMPONENT . "/lib/libpdf/lang/ita.php");
                $pdf->setLanguageArray($l);
            }

            $pdf->AddPage();

            $html = self::minifyhtml('
                    <style>
                        table, tr, td {padding: 0; margin: 0; border-collapse: collapse;}
                        table td {vertical-align: middle;}
                        table tr.row td {
                            border-bottom: 1px solid #000000!important;
                            height: 23px;
                        }
                        p {margin: 0!important; padding: 0}
                        img {display: inline-block}
                        .center {text-align: center}
                        .bold {font-weight: bold}
                        .bd-left {border-left: 1px solid #000!important}
                        .bd-bottom {border-bottom: 1px solid #000!important}
                        .bd-right {border-right: 1px solid #000!important}
                        .bd-top {border-top: 1px solid #000!important}
                        .bd-lg {border: 1px solid #000!important;}
                        .rotate {-webkit-transform: rotate(270deg); -moz-transform: rotate(270deg); -ms-transform: rotate(270deg); -o-transform: rotate(270deg); transform: rotate(270deg);}
                    </style>
                    <table style="width: 100%;" class="bd-lg" cellpadding="3">
                        <tr>
                            <td colspan="3" class="center bd-bottom"><h2>Scheda operativa del DUVRI Integrativo</h2></td>
                        </tr>
                        <tr>
                            <td width="5%" class="bd-right"></td>
                            <td width="90%" class="bd-top">
                                <h4 class="center bold">CAMPO 1 - Informazioni generali:</h4>
                                <div style="font-size: 11px">
                                    <b>Data inizio lavoro:</b>&nbsp;<tt>' . date("d/m/Y", strtotime($info->inizioLavori)) . '</tt>&nbsp;<b>Contratto n.:</b>&nbsp;' . ($info->nrChiamata . ($info->nrChiamataCompagnia ? " - {$info->nrChiamataCompagnia}" : "")) . '&nbsp;<b>del:</b>&nbsp;' . date("d/m/Y", strtotime($info->dataApertura)) . '<br/>
                                    <b>Data prevista per la fine del lavoro:</b>&nbsp;' . date("d/m/Y", strtotime($info->fineLavori)) . '<br/>
                                    <b>Apparecchiatura o zona di lavoro:</b>&nbsp;' . $info->equipment . '<br/>
                                    <b>Descrizione del lavoro:</b>&nbsp;' . $info->note . '<br/>
                                    <b>Ragione sociale Impresa n. 1:</b>&nbsp;' . $ragioniSociali[$info->idLogo] . '<br/>
                                    <b>Nominativo del Respo. / Preposto Impresa:</b>&nbsp;' . $info->name . '
                                </div>
                            </td>
                            <td width="5%" class="bd-left bd-top"></td>
                        </tr>
                        <tr>
                            <td class="bd-right"></td>
                            <td class="bd-top">
                                <h4 class="center bold">CAMPO 2 - Tipo di interferenza:</h4>
                                <table cellpadding="2" width="100%" style="font-size: 11px;">
                                    <tr>
                                        <td width="3%">a)</td>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->tipo == 1 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Nessuna interferenza significativa (non occorre compilare i rimanenti campi).</td>
                                    </tr>
                                    <tr>
                                        <td width="3%">b)</td>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->tipo == 2 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Possibile interferenza significativa coin l\'attività del personale del Punto Vendita. È compresa nella valutazione l\'eventuale interferenza tra i rischi legati alla struttura, alle attività ed ai prodotti del Punto Vendita ed i rieschi generati da lavori / mezzi dell\'impresa - <b>Compilare i CAMPI 3 e 4</b></td>
                                    </tr>
                                    <tr>
                                        <td width="3%">c)</td>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->tipo == 3 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Possibile interferenza con altri lavori / imprese in zona. In questo caso elencare tali lavori / imprese. - <b>Compilare i CAMPI 3 e 4</b>
                                            ' . $imprese . '</td>
                                    </tr>
                                </table>
                            </td>
                            <td class="bd-left bd-top"></td>
                        </tr>
                        <tr>
                            <td class="bd-right"></td>
                            <td class="bd-top">
                                <h4 class="center bold">CAMPO 3 - Rieschio accettabile con prescrizioni:</h4>
                                <b>Precauzioni a carico dell\'Impresa n.1:</b><br/>
                                <table cellpadding="2" width="100%" style="font-size: 11px;">
                                    <tr>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->rischio == 1 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Isolare/delimitare/segnalare l\'area di lavoro.</td>
                                    </tr>
                                    <tr>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->rischio == 2 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Protezioni da adottare in caso di lavori in quota:</td>
                                    </tr>
                                    <tr>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->rischio == 3 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Informare il proprio personale di operazioni sull\'area di lavoro da parte del personale del gestore del p.v.</td>
                                    </tr>
                                    <tr>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->rischio == 4 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Sospendere i lavori durante l\'esecuzione di operazioni sull\'area di lavoro da parte del personale  del p.v.</td>
                                    </tr>
                                    <tr>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->rischio == 5 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Altre (descrivere): ' . ($info->rischio == 5 && $info->altreRischio != "" ? $info->altreRischio : "") . '</td>
                                    </tr>
                                </table><br/><br/>
                                <b>Precauzioni a carico del Gestore del P.to Vendita:</b><br/>
                                <table cellpadding="2" width="100%" style="font-size: 11px;">
                                    <tr>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->precauzioni == 1 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Informare il personale dell\'impresa di altri lavori in corso nell\'area di lavoro</td>
                                    </tr>
                                    <tr>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->precauzioni == 2 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Vietare l\'accesso all\'area lavori</td>
                                    </tr>
                                    <tr>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->precauzioni == 3 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Procedere ad eventuali operazioni nell\'area lavori solo previa sospensione degli stessi e messa in sicurezza dell\'area da parte dell\'Impresa 1.</td>
                                    </tr>
                                    <tr>
                                        <td width="3%"><table width="12" height="3"><tr><td class="bd-lg center">' . ($info->precauzioni == 4 ? "X" : "&nbsp;") . '</td></tr></table></td>
                                        <td width="94%">Altre (descrivere): ' . ($info->precauzioni == 4 && $info->altrePrecauzioni != "" ? $info->altrePrecauzioni : "") . '</td>
                                    </tr>
                                </table>
                            </td>
                            <td class="bd-left bd-top"></td>
                        </tr>
                        <tr>
                            <td class="bd-right"></td>
                            <td class="bd-top">
                                <h4 class="center bold">CAMPO 4 - Eventuali allegati (verbali di riunione, programmi lavori, ecc.), firme dei soggetti che hanno partecipato alla compilazione della scheda, ed eventuale stato di revisione della stessa</h4>
                                <p style="font-size: 11px;">' . $info->statoRevisione . '</p><br/>
                                <b>Revisione/integrazione n°:</b>&nbsp;' . ($info->revisionNumber ? $info->revisionNumber : '-') . '&nbsp;<b>del:</b>&nbsp;' . (strtotime($info->dataRevisione) ? date("d/m/Y", strtotime($info->dataRevisione)) : '-') . '<br/>
                                <br/>Timbro e firma del Gestore del P.to vendita:<br/><br/>
                                <table style="width: 100%">
                                    <tr><td style="width:33%"><img src="' . $arrayNF[0] . '" style="max-width: 100%" /></td><td style="width:50%"></td></tr>
                                </table>
                                <table style="width: 100%" class="bd-top" style="font-size: 11px">
                                    <tr>
                                        <td style="width:25%" class="bd-right">
                                            Impresa n. 1:<br><br><img src="' . $arrayNF[1] . '" style="max-width: 100%" />
                                        </td>
                                        <td style="width:25%" class="bd-right">
                                            ' . ($arrayNF[2] ? "Impresa n. 2:<br><br><img src=\"" . $arrayNF[2] . "\" style='max-width: 100%' />" : "") . '
                                        </td>
                                        <td style="width:25%" class="bd-right">
                                            ' . ($arrayNF[3] ? "Impresa n. 3:<br><br><img src=\"" . $arrayNF[3] . "\" style='max-width: 100%' />" : "") . '
                                        </td>
                                        <td style="width:25%">
                                            ' . ($arrayNF[4] ? "Impresa n. 4:<br><br><img src=\"" . $arrayNF[4] . "\" style='max-width: 100%' />" : "") . '
                                        </td>
                                    </tr>
                                </table>
                            </td>
                            <td class="bd-left bd-top"></td>
                        </tr>
                        <tr>
                            <td colspan="3" class="center bd-top"><p style="font-size: 10px">Modulo in 5 copie chimiche - Una copia per il Gestore - Una per l\'impresa in assenza di interferenze - Una per ogni impresa se vi sono interferenze</p></td>
                        </tr>
                    </table>');

            $pdf->writeHTMLCell(0, 0, 5, 5, $html, 0, 2, false, true, "", true);

            $pdf->lastPage();
            $pdf->Output($filepath, 'F'); //sostituire I con F per creare il file

            if ($arrayNF) {
                foreach ($arrayNF as $firma) {
                    @unlink($firma);
                }
            }
        }

        if ($usepost === true) {
            //stampa
            header("Pragma: public");
            header("Expires: 0");
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header("Cache-Control: public");
            header('Content-type: application/pdf');
            header('Content-Disposition: inline; filename="' . $filename . '"');
            header('Content-Transfer-Encoding: binary');
            header('Accept-Ranges: bytes');
            header("Content-Length: " . filesize($filepath));
            ob_end_flush();
            readfile($filepath);
            exit;
        }
        return $filepath;
    }

    public function visualizzaPDFrapporto($usepost = true, $idchiamata = null) {

        $dbo = JFactory::getDbo();
        if ($usepost === true) {
            $idRapporto = JRequest::getVar("idRapporto");
            $idChiamata = JRequest::getVar("idChiamata");
        } else {
            $idRapporto = $usepost;
            $idChiamata = $idchiamata;
        }

        $query = $dbo->getQuery(true);
        $query->select("*, c.tipo as tipoPDF")
                ->from("#__osma_chiamate as c")
                ->innerJoin("#__osma_chiamata_interventi AS i ON i.idChiamata = c.idChiamata")
                ->innerJoin("#__osma_duvri AS d ON d.idIntervento = i.idIntervento")
                ->innerJoin("#__osma_duvri_rapporto AS r ON d.id = r.idDuvri")
                ->where("r.idRapporto = " . $dbo->q($idRapporto));

        $dbo->setQuery($query);
        $info = $dbo->loadObject();
        $query->clear();

        $filename = "intervento-{$info->idIntervento}-rapporto-" . strtotime($info->dataIntervento) . ".pdf";

        $filepath = JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/{$filename}";
        $fileurl = JURI::root() . "/components/com_osma/files/chiamate/{$idChiamata}/{$filename}";

        if (!file_exists($filepath) || JRequest::getVar("update")) {

            $query->select("*")
                    ->from("#__osma_duvri")
                    ->where("idIntervento = " . $dbo->q($info->idIntervento));

            $dbo->setQuery($query);

            $duvri = $dbo->loadObject();

            $model = self::getModel('Chiusura', 'OsmaModel');

            $gestore = $model->getgestore($info->idGestore);
            $rapporto = $model->getrapporto($duvri->id);
            $team = $model->getteam($info->idIntervento, $info->idChiamata);
            $matricole = $model->getmatricole($info->idGestore, 5);
            $matricoleCC = $model->getmatricolepagamento($info->idGestore, 4);
            $matricoleSS = $model->getmatricolepagamento($info->idGestore, 3);

            if (!is_dir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/")) {
                mkdir(JPATH_COMPONENT . "/files/chiamate/{$idChiamata}/");
            }

            $h = "L";
            if ($info->idCompagnia == 7 && $info->tipoPDF != 2) {
                $h = "P";
            }

            include_once JPATH_COMPONENT . "/lib/libpdf/tcpdf_include.php";

            $pdf = new TCPDF($h, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
            $pdf->setCreator(PDF_CREATOR);
            $pdf->setFont('helvetica', '', 10);
            $pdf->setDefaultMonospacedFont(PDF_FONT_MONOSPACED);
            $pdf->setMargins(5, 5);
            $pdf->setFooterMargin(0);
            $pdf->setPrintHeader(false);
            $pdf->setPrintFooter(false);
            $pdf->setAutoPageBreak(false);
            $pdf->setCellPadding(0);

            $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
            if (@file_exists(JPATH_COMPONENT . "/lib/libpdf/lang/ita.php")) {
                require_once(JPATH_COMPONENT . "/lib/libpdf/lang/ita.php");
                $pdf->setLanguageArray($l);
            }

            $params = $pdf->serializeTCPDFtagParameters(array(90));

            $mainStyle = "
                <style>
                    table, tr, td {padding: 0; margin: 0; border-collapse: collapse;}
                    table td {vertical-align: middle;}
                    table tr.row td {
                        border-bottom: 1px solid #000000!important;
                    }
                    table thead td {font-size: 50px;}
                    .center {text-align: center}
                    .bd-left {border-left: 1px solid #000!important}
                    .bd-bottom {border-bottom: 1px solid #000!important}
                    .bd-right {border-right: 1px solid #000!important}
                    .bd-top {border-top: 1px solid #000!important}
                    .bd-lg {border: 2px solid #000!important}
                    .th {text-align: center; vertical-align: middle; font-weight: bold; white-space: nowrap;}
                </style>";

            if ($info->idCompagnia == 7) {
                if ($info->tipoPDF == 2) {
                    include(JPATH_COMPONENT . "/templates/pdf/rapporto-eni-extra.php");
                } else {
                    include(JPATH_COMPONENT . "/templates/pdf/rapporto-eni-standard.php");
                }
            } else {
                include(JPATH_COMPONENT . "/templates/pdf/rapporto-standard.php");
            }

            $pdf->lastPage();
            $pdf->Output($filepath, 'F'); //sostituire I con F per creare il file

            if ($arrayNF) {
                foreach ($arrayNF as $firma) {
                    if (file_exists(JPATH_BASE . "/{$firma}")) {
                        @unlink(JPATH_BASE . "/{$firma}");
                    }
                }
            }
            if ($array2NF) {
                foreach ($array2NF as $firma) {
                    if (file_exists(JPATH_BASE . "/{$firma}")) {
                        @unlink(JPATH_BASE . "/{$firma}");
                    }
                }
            }
        }


        if ($usepost === true) {
            //stampa
            header("Pragma: public");
            header("Expires: 0");
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header("Cache-Control: public");
            header('Content-type: application/pdf');
            header('Content-Disposition: inline; filename="' . $filename . '"');
            header('Content-Transfer-Encoding: binary');
            header('Accept-Ranges: bytes');
            header("Content-Length: " . filesize($filepath));
            ob_end_flush();
            readfile($filepath);
            exit;
        }
        return $filepath;
    }

    public function dichiarazioneRiparazione() {
        $idRapporto = JRequest::getVar("idRapporto");
        $idChiamata = JRequest::getVar("idChiamata");

        $dbo = JFactory::getDBO();

        $query = $dbo->getQuery(true);

        $query->select("R.*, C.idChiamata, G.*, Co.compagnia, U.name as manutentore")
                ->from("#__osma_duvri_rapporto R")
                ->innerJoin("#__osma_duvri D ON D.id = R.idDuvri")
                ->innerJoin("#__osma_chiamata_interventi I ON I.idIntervento = D.idIntervento")
                ->innerJoin("#__users U ON U.id = I.idInviaMailA")
                ->innerJoin("#__osma_chiamate C ON C.idChiamata = I.idChiamata")
                ->innerJoin("#__osma_anagrafica_gestori G ON G.idGestore = C.idGestore")
                ->innerJoin("#__osma_anagrafica_compagnie Co ON C.idCompagnia = Co.idCompagnia")
                ->where("R.idRapporto = " . (int) $idRapporto);

        $rapporto = $dbo->setQuery($query)->loadObject();

        $query->clear();
        $query->select("d.*, m.nrMatricola, M.modello, MA.marca, T.tipologia")
                ->from("#__osma_duvri_rapporto_distributori d")
                ->innerJoin("#__osma_anagrafica_pistole p ON p.idPistola = d.idMatricola")
                ->innerJoin("#__osma_anagrafica_matricole m ON m.idMatricola = p.idMatricola")
                ->innerJoin("#__osma_anagrafica_modelli M ON m.idModello = M.idModello")
                ->innerJoin("#__osma_anagrafica_marche MA ON m.idMarca = MA.idMarca")
                ->innerJoin("#__osma_anagrafica_tipologie T ON m.idTipologia = T.idTipologia")
                ->where("m.deleted = 0")
                ->where("LTRIM(RTRIM(LOWER(normativa))) = 'nazionale'")
                ->where("piombi = 1")
                ->where("idRapporto = " . $dbo->q($rapporto->idRapporto));

        $pistole = $dbo->setQuery($query)->loadObjectList();
        $rapporto->distributori = $pistole;

        $filename = "dichiarazione-intervento-{$rapporto->idRapporto}-" . strtotime($rapporto->dataIntervento) . ".pdf";

        ob_start();
        include(JPATH_COMPONENT . "/templates/pdf/dichiarazione-rapporto.php");
        $result = self::minifyhtml(ob_get_clean());


        require_once(JPATH_COMPONENT_SITE . "/lib/dompdf/autoload.inc.php");

        $dompdf = new Dompdf\Dompdf();
        $dompdf->loadHtml($result);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $dompdf->stream("richiesta-rapporto-{$rapporto->idRapporto}-" . time(), array("Attachment" => false));
        exit;
    }

    public function generaLibretto() {
        $user = JFactory::getUser();
        $idMatricola = JRequest::getVar("idMatricola");
        $idIntervento = JRequest::getVar("idIntervento");

        if (!$idMatricola || !$idIntervento) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $libretto = new stdClass();
        $libretto->idIntervento = $idIntervento;
        $libretto->idMatricola = $idMatricola;
        $libretto->idUser = $user->id;

        $dbo = JFactory::getDbo();
        $dbo->insertObject("#__osma_rapporto_libretti_metrologici", $libretto, 'idLibretto');

        $libretto->idLibretto = $dbo->insertid();
        $libretto->librettoMetrologico = self::creaLibretto($libretto);
        $dbo->updateObject("#__osma_rapporto_libretti_metrologici", $libretto, 'idLibretto');



        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function visualizzaLibretto() {
        $idLibretto = JRequest::getVar("idLibretto");

        if (!$idLibretto) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();

        $libretto = $dbo->setQuery("SELECT * FROM #__osma_rapporto_libretti_metrologici WHERE idLibretto = {$idLibretto}")->loadObject();

        if (!$libretto) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        if (!$libretto->librettoMetrologico || JRequest::getVar("update")) {
            $libretto->librettoMetrologico = self::creaLibretto($libretto);
            $dbo->updateObject("#__osma_rapporto_libretti_metrologici", $libretto, 'idLibretto');
        }

        require_once(JPATH_COMPONENT_SITE . "/lib/dompdf/autoload.inc.php");

        $dompdf = new Dompdf\Dompdf();
        $dompdf->loadHtml($libretto->librettoMetrologico);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $dompdf->stream("libretto-mtrologico-{$libretto->idLibretto}-" . time(), array("Attachment" => false));

        JApplication::close();
    }

    static function creaLibretto($libretto) {
        $user = JFactory::getUser($libretto->idUser);

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);
        $query->select("tipologia, marca, modello, nrMatricola, ragioneSociale, indirizzo, comune, provincia, cap, piva, cf, nrRea, nrPuntoVendita, compagnia")
                ->from("#__osma_rapporto_libretti_metrologici l")
                ->leftJoin("#__osma_anagrafica_matricole m ON m.idMatricola = l.idMatricola")
                ->leftJoin("#__osma_xref_gestore_matricole xM ON xM.idMatricola = m.idMatricola")
                ->leftJoin("#__osma_anagrafica_gestori g ON xM.idGestore = g.idGestore")
                ->leftJoin("#__osma_anagrafica_compagnie c ON c.idCompagnia = g.idCompagnia")
                ->leftJoin("#__osma_anagrafica_modelli M ON M.idModello = m.idModello")
                ->leftJoin("#__osma_anagrafica_tipologie T ON T.idTipologia = M.idTipologia")
                ->leftJoin("#__osma_anagrafica_marche MA ON MA.idMarca = M.idMarca")
                ->where("mt.deleted = 0")
                ->where("l.idLibretto = {$libretto->idLibretto}");

        $oggetto = $dbo->setQuery($query)->loadObject();

        if ($libretto->idPistole) {
            $libretto->idPistole = unserialize($libretto->idPistole);
        }
        $query->clear()
                ->select("matricolaPistola, sA, sPA, aP")
                ->from("#__osma_anagrafica_pistole p")
                ->leftJoin("#__osma_anagrafica_matricole m ON m.idMatricola = p.idMatricola")
                ->leftJoin("#__osma_duvri_rapporto_distributori dR ON dR.idMatricola = p.idPistola")
                ->leftJoin("#__osma_duvri_rapporto R ON R.idRapporto = dR.idRapporto")
                ->leftJoin("#__osma_duvri D ON D.id = R.idDuvri")
                ->where("mt.deleted = 0")
                ->where("idPistola IN (" . implode(",", $libretto->idPistole) . ")")
                ->where("D.idIntervento = {$libretto->idIntervento}");

        $pistole = $dbo->setQuery($query)->loadObjectlist();

        $query->clear()
                ->select("signaturePtoVendita, firma2")
                ->from("#__osma_duvri d")
                ->innerJoin("#__osma_duvri_rapporto r ON r.idDuvri = d.id")
                ->innerJoin("#__osma_duvri_rapporto_distributori di ON di.idRapporto = r.idRapporto")
                ->innerJoin("#__osma_rapporto_libretti_metrologici l ON l.idIntervento = d.idIntervento")
                ->where("idLibretto = {$libretto->idLibretto}");

        $additional = $dbo->setQuery($query)->loadObject();

        ob_start();
        include(JPATH_COMPONENT . "/templates/pdf/libretto-metrologico.php");
        return self::minifyhtml(ob_get_clean());
    }

    public function visualizzaChecklist() {
        $idChecklist = JRequest::getVar("idChecklist");

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("C.*, RP.firma1, RP.firma2, G.*, CO.*")
                ->from("#__osma_checklist C")
                ->innerJoin("#__osma_chiamata_interventi I ON I.idIntervento = C.idIntervento")
                ->innerJoin("#__osma_duvri DV ON DV.idIntervento = I.idIntervento")
                ->innerJoin("#__osma_duvri_rapporto RP ON DV.id = RP.idDuvri")
                ->innerJoin("#__osma_chiamate CH ON CH.idChiamata = I.idChiamata")
                ->innerJoin("#__osma_anagrafica_gestori G ON G.idGestore = CH.idGestore")
                ->innerJoin("#__osma_anagrafica_compagnie CO ON G.idCompagnia = CO.idCompagnia")
                ->where("idChecklist = {$idChecklist}");

        $checklist = $dbo->setQuery($query)->loadObject();
        $checklist->checks = unserialize($checklist->checks);

        ob_start();
        include(JPATH_COMPONENT . "/templates/pdf/checklist.php");
        $html = self::minifyhtml(ob_get_clean());

        $dompdf = new Dompdf();
        $dompdf->loadHtml($html);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $dompdf->stream("libretto-mtrologico-{$libretto->idLibretto}-" . time(), array("Attachment" => false));

        print_r($checklist);
        exit;
    }

    static function minifyhtml($buffer) {

        $search = array(
            '/\>[^\S ]+/s', // strip whitespaces after tags, except space
            '/[^\S ]+\</s', // strip whitespaces before tags, except space
            '/(\s)+/s'       // shorten multiple whitespace sequences
        );

        $replace = array(
            '>',
            '<',
            '\\1'
        );

        $buffer = preg_replace($search, $replace, $buffer);

        $buffer = str_replace(array(' </', "> <"), array("</", "><"), $buffer);

        return trim($buffer);
    }

}
