<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT_SITE . "/lib/dompdf/autoload.inc.php");

use Dompdf\Dompdf;

class osmaControllerPreventivatore extends JControllerLegacy {

    public function addCapitolo() {
        $input = JRequest::get("post");

        $obj = new stdClass();
        $obj->idCapitoloGenitore = $input['idCapitoloGenitore'];
        $obj->descrizione = $input['descrizione'];
        $obj->codiceCapitolo = $input['codiceCapitolo'];
        $obj->prezziario = $input['prezziario'];
        $obj->nome = $input['nome'];
        $obj->um = $input['um'];
        $obj->prezzoUnitario = $input['prezzoUnitario'];

        if ($input['idCapitolo']) {
            $obj->idCapitolo = $input['idCapitolo'];
            JFactory::getDbo()->updateObject('#__osma_preventivatore_capitolato', $obj, 'idCapitolo');
        } else {
            JFactory::getDbo()->insertObject('#__osma_preventivatore_capitolato', $obj, 'idCapitolo');
        }

        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function removeCapitolo() {
        $id = JRequest::getVar("id");

        if (!$id) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("*")->from("#__osma_preventivatore_capitolato")->where("idCapitolo = {$id}");
        $result = $dbo->setQuery($query)->loadObject();

        $oldIDCapitolo = $result->idCapitolo;
        $newIDCapitolo = $result->idCapitoloGenitore;

        $dbo->setQuery("DELETE FROM #__osma_preventivatore_capitolato WHERE idCapitolo = {$id}")->execute();
        $dbo->setQuery("UPDATE #__osma_preventivatore_capitolato SET idCapitoloGenitore = {$newIDCapitolo} WHERE idCapitoloGenitore = {$oldIDCapitolo}")->execute();

        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function getCapitolo() {
        $id = JRequest::getVar("id");

        if (!$id) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("*")->from("#__osma_preventivatore_capitolato")->where("idCapitolo = {$id}");
        $obj = $dbo->setQuery($query)->loadObject();
        $obj->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($obj);

        echo new JResponseJson($obj, null);
        JApplication::close();
    }

    public function getCapitoliChildren() {
        $id = JRequest::getVar("id");
        $q = JRequest::getVar("q");

        if (!$id && !$q) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("*")->from("#__osma_preventivatore_capitolato")->where("um != '' AND um IS NOT NULL")->order("codiceCapitolo, nome");

        if ($id) {
            $query->where("idCapitoloGenitore = {$id}");
        }
        if ($q) {
            $query->where("(nome LIKE '%" . $q . "%' or descrizione LIKE '%" . $q . "%')");
        }

        $objectL = $dbo->setQuery($query)->loadObjectList();

        foreach ($objectL as $item) {
            $item->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($item);
        }

        echo new JResponseJson($objectL, null);
        JApplication::close();
    }

    public function calcolaTotale() {
        $post = JRequest::get('post');

        $preventivo = array();
        $lordo = 0;
        $finale = 0;
        if ($post) {
            foreach ($post['idCapitolo'] as $k => $idCapitolo) {
                $preventivo[] = (object) array(
                            'quantita' => $post['quantita'][$k],
                            'prezzoUnitario' => $post['prezzoUnitario'][$k],
                            'sconto' => $post['sconto'][$k],
                );
            }
        }


        foreach ($preventivo as $row) {
            $totale = $row->quantita * $row->prezzoUnitario;
            $valoreS = ($totale / 100) * $row->sconto;
            $totalescontato = round($totale - $valoreS, 2);

            $finale += $totalescontato;
            $lordo += $totale;
        }

        echo new JResponseJson(array('lordo' => number_format($lordo, 2, ",", "."), 'lavori' => number_format($finale, 2, ",", ".")), null);
        JApplication::close();
    }

    public function aggiungiPreventivo() {

        $post = JRequest::get('post');
        if (!$post['idCapitolo']) {

        }

        $dbo = JFactory::getDbo();

        $obj = new stdClass();
        $obj->note = JRequest::getVar("note");
        if (JRequest::getVar("idPreventivo")) {
            $idPreventivo = JRequest::getVar("idPreventivo");
            $obj->idPreventivo = $idPreventivo;
            $dbo->updateObject("#__osma_preventivatore_preventivi", $obj, 'idPreventivo');
        } else {
            $obj->idChiamata = JRequest::getVar("idChiamata");
            $dbo->insertObject("#__osma_preventivatore_preventivi", $obj);

            $idPreventivo = $dbo->insertid();

            $dbo->setQuery("UPDATE #__osma_chiamate SET consuntivata = 1 WHERE idChiamata = " . $obj->idChiamata)->execute();
        }

        $dbo->setQuery("DELETE FROM #__osma_preventivatore_preventivi_voci WHERE idPreventivo = " . $idPreventivo)->execute();

        foreach ($post['idCapitolo'] as $k => $idCapitolo) {
            $voce = new stdClass();
            $voce->idCapitolo = $idCapitolo;
            $voce->prezzoUnitario = $post['prezzoUnitario'][$k];
            $voce->quantita = $post['quantita'][$k];
            $voce->nome = $post['nome'][$k];
            $voce->um = $post['um'][$k];
            $voce->sconto = $post['sconto'][$k];
            $voce->note = $post['note'][$k];
            $voce->idPreventivo = $idPreventivo;
            $dbo->insertObject("#__osma_preventivatore_preventivi_voci", $voce);
        }

        JFactory::getApplication()->redirect(osmaHelper::router("index.php?option=com_osma&view=preventivatore&layout=preventivo&idPreventivo=" . $idPreventivo), 'Preventivo salvato correttamente');
    }

    public function inviaPreventivo() {
        $indirizzi = JRequest::get("post")['indirizzi'];

        if (!$indirizzi) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $to = array();
        foreach ($indirizzi as $field) {
            $explode = explode(",", $field);
            foreach ($explode as $email) {
                $email = trim($email);
                if (filter_var($email, FILTER_VALIDATE_EMAIL) !== false) {
                    $to[] = filter_var($email, FILTER_VALIDATE_EMAIL);
                }
            }
        }
        if (!$to) {
            echo new JResponseJson(null, null, true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();

        $preventivo = $dbo->setQuery("SELECT * FROM #__osma_preventivatore_preventivi WHERE idPreventivo = " . JRequest::getVar("idPreventivo"))->loadObject();
        $chiamata = $dbo->setQuery("SELECT * FROM #__osma_chiamate WHERE idChiamata = " . $dbo->q($preventivo->idChiamata))->loadObject();

        $config = JFactory::getConfig();
        $mailer = JFactory::getMailer();
        $mailer->setSender(array(
            $config->get('mailfrom'),
            $config->get('fromname')
        ));
        $mailer->setSubject('Invio preventivo nr. ' . str_pad($preventivo->idPreventivo, 6, "0", STR_PAD_LEFT) . "/" . date("Y", strtotime($preventivo->inserted)) . " - Rif. chiamata: " . $chiamata->nrChiamata . ' da OSMA SNC');
        $mailer->setBody("In allegato trovate preventivo nr. " . str_pad($preventivo->idPreventivo, 6, "0", STR_PAD_LEFT) . "/" . date("Y", strtotime($preventivo->inserted)) . " - Rif. chiamata: " . $chiamata->nrChiamata . " da OSMA SNC. Si prega di inviarlo compilato in ogni sua parte all'indirizzo email " . COM_OSMA_MAIL_UFFICIO);

        if (JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug") && JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address")) {
            $mailer->addCC(JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address"));
        }

        foreach ($to as $mail) {
            if (trim($mail)) {
                $mailer->addRecipient(trim($mail));
            }
        }

        $ida = uniqid() . time();
        file_put_contents(JPATH_COMPONENT . "/tmp/{$ida}.pdf", file_get_contents(JUri::root() . "index.php?option=com_osma&task=preventivatore.stampaPreventivo&format=raw&idPreventivo={$preventivo->idPreventivo}"));
        $mailer->addAttachment(JPATH_COMPONENT . "/tmp/{$ida}.pdf");

        if ($mailer->Send() !== true) {
            mailerHelper::logMail($mailer, 7, false, $preventivo->idPreventivo);
            echo new JResponseJson(null, "Errore", true);
        } else {
            mailerHelper::logMail($mailer, 7, true, $preventivo->idPreventivo);
            echo new JResponseJson(null, null);
        }

        unlink(JPATH_COMPONENT . "/tmp/{$ida}.pdf");
        JApplication::close();
    }

    public function stampaPreventivo() {
        $idPreventivo = JRequest::getVar("idPreventivo");
        $dbo = JFactory::getDbo();


        $preventivo = $dbo->setQuery("SELECT * FROM #__osma_preventivatore_preventivi WHERE idPreventivo = " . $dbo->q($idPreventivo))->loadObject();
        $preventivo->voci = $dbo->setQuery("SELECT v.*, c.idCapitoloGenitore, c.codiceCapitolo FROM #__osma_preventivatore_preventivi_voci v LEFT OUTER JOIN #__osma_preventivatore_capitolato c ON c.idCapitolo = v.idCapitolo WHERE idPreventivo = " . $dbo->q($preventivo->idPreventivo))->loadObjectList();
        $chiamata = $dbo->setQuery("SELECT * FROM #__osma_chiamate WHERE idChiamata = " . $dbo->q($preventivo->idChiamata))->loadObject();
        $cliente = $dbo->setQuery("SELECT * FROM #__osma_anagrafica_clienti WHERE idCliente = " . $dbo->q($chiamata->idCliente))->loadObject();
        $gestore = $dbo->setQuery("SELECT * FROM #__osma_anagrafica_gestori WHERE idGestore = " . $dbo->q($chiamata->idGestore))->loadObject();

        foreach ($preventivo->voci as $item) {
            $item->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($item);
            $totale = $item->prezzoUnitario * $item->quantita;
            $item->totale = round($totale, 2);

            $valoreS = ($totale / 100) * $item->sconto;
            $valore = $totale - $valoreS;
            $item->importo = round($valore, 2);

            $preventivo->totaleLavori += $totale;
            $preventivo->totalePreventivo += $valore;
        }

        $preventivo->totaleLavori = round($preventivo->totaleLavori, 2);
        $preventivo->totalePreventivo = round($preventivo->totalePreventivo, 2);

        ob_start();
        require_once (JPATH_COMPONENT_SITE . "/templates/pdf/preventivatore-preventivo.php");
        $result = ob_get_clean();

        $dompdf = new Dompdf();
        $dompdf->loadHtml($result);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $dompdf->stream("preventivo-" . str_pad($preventivo->idPreventivo, 6, "0", STR_PAD_LEFT) . "-" . date("Y", strtotime($preventivo->inserted)) . "-" . time());
        exit;
    }

    public function getVociPreventivo() {

        $dbo = JFactory::getDbo();
        $voci = $dbo->setQuery("SELECT v.*, c.idCapitoloGenitore, c.codiceCapitolo FROM #__osma_preventivatore_preventivi_voci v LEFT OUTER JOIN #__osma_preventivatore_capitolato c ON c.idCapitolo = v.idCapitolo WHERE idPreventivo = " . $dbo->q(JRequest::getVar("idPreventivo")))->loadObjectList();

        ob_start();
        foreach ($voci as $item) {
            $item->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($item);
            ?>
            <div class="clearfix" style="padding-top: 7.5px; padding-bottom: 7.5px;">
                <div class="col-sm-1 text-left">
                    <input type="checkbox" name="idVoce[]" value="<?php echo $item->idVoce ?>" />
                </div>
                <div class="col-sm-4 text-left">
                    <div class="row" style='max-width: 100%; white-space: nowrap; text-overflow: ellipsis; overflow: hidden;'>
                        <?php echo $item->codiceCapitoloRaw ? $item->codiceCapitoloRaw : "-" ?>
                    </div>
                </div>
                <div class="col-sm-6 text-left" style="">
                    <div class="row" style='max-width: 100%; white-space: nowrap; text-overflow: ellipsis; overflow: hidden;'>
                        <?php echo $item->nome ?>
                    </div>
                </div>
            </div>
            <?php
        }

        echo new JResponseJson(ob_get_clean(), null);
        JApplication::close();
    }

    public function copiaVoci() {
        parse_str(JRequest::getVar('copia'), $copia);

        if (!$copia['idVoce']) {
            echo new JResponseJson(null, "Errore", true);
            JApplication::close();
        }

        $dbo = JFactory::getDbo();
        $obj = new stdClass();
        $obj->note = JRequest::getVar("note");
        if (JRequest::getVar("idPreventivo")) {
            $idPreventivo = JRequest::getVar("idPreventivo");
            $obj->idPreventivo = $idPreventivo;
            $dbo->updateObject("#__osma_preventivatore_preventivi", $obj, 'idPreventivo');
        } else {
            $obj->idChiamata = JRequest::getVar("idChiamata");
            $dbo->insertObject("#__osma_preventivatore_preventivi", $obj);

            $idPreventivo = $dbo->insertid();

            $dbo->setQuery("UPDATE #__osma_chiamate SET consuntivata = 1 WHERE idChiamata = " . $obj->idChiamata)->execute();
        }

        $dbo->setQuery("INSERT INTO #__osma_preventivatore_preventivi_voci (idPreventivo, idCapitolo, nome, prezzoUnitario, quantita, um, sconto, note) SELECT " . $idPreventivo . ", idCapitolo, nome, prezzoUnitario, quantita, um, sconto, note FROM #__osma_preventivatore_preventivi_voci WHERE idVoce IN (" . implode(",", $copia['idVoce']) . ")");
        $dbo->execute();

        echo new JResponseJson(osmaHelper::router("index.php?option=com_osma&view=preventivatore&layout=preventivo&idPreventivo=" . $idPreventivo), null);
        JApplication::close();
    }

}
