<?php

/**
 * @package     Joomla.Administrator
 * @subpackage  com_helloworld
 *
 * @copyright   Copyright (C) 2005 - 2016 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * HelloWorld Model
 *
 * @since  0.0.1
 */
class OsmaModelChiamate extends JModelList {

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search', 'status', 'type', 'comune', 'filter_manutentore', 'data'
        );
        parent::__construct($config);

        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication();

        $this->setState('filter.search', $app->getUserStateFromRequest($this->context . ".filter.search", "filter_search"));
        $this->setState('filter.status', $app->getUserStateFromRequest($this->context . ".filter.status", "filter_status"));
        $this->setState('filter.type', $app->getUserStateFromRequest($this->context . ".filter.type", "filter_type"));
        $this->setState('filter.tipoChiamata', $app->getUserStateFromRequest($this->context . ".filter.tipoChiamata", "filter_chiamata"));
        $this->setState('filter.comune', $app->getUserStateFromRequest($this->context . ".filter.comune", "filter_comune"));
        $this->setState('filter.scadute', $app->getUserStateFromRequest($this->context . ".filter.scadute", "filter_scadute"));
        $this->setState('filter.incorso', $app->getUserStateFromRequest($this->context . ".filter.incorso", "filter_incorso"));
        $this->setState('filter.data', $app->getUserStateFromRequest($this->context . ".filter.data", "filter_data"));
        $this->setState('filter.manutentore', $app->getUserStateFromRequest($this->context . ".filter.manutentore", "filter_manutentore"));
    }

    public function getPagination() {
        $jpagination = new JPagination($this->getTotal(), $this->limitstart, $this->limit);

        return $jpagination;
    }

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();

        $db->setQuery($query, $this->limitstart, $this->limit);

        $results = $db->loadObjectList();

        foreach ($results as $key => $res) {
            if ($res->idGestore) {
                $query = "SELECT telefono FROM #__osma_gestori_contatti WHERE idGestore=" . $res->idGestore;
                $db->setQuery($query);
                $contatti = $db->loadObjectList();
                $results[$key]->contatti = $contatti;
            } else {
                $results[$key]->contatti = array();
            }

            $query = "
                SELECT  idPreventivo
                FROM     #__osma_preventivatore_preventivi
                WHERE idChiamata = " . $res->idChiamata . " 
                ORDER BY inserted DESC";

            $db->setQuery($query);
            $results[$key]->idPreventivo = $db->loadResult();

            $query = "
                SELECT  c.*, u.name, p.idPreventivo
                FROM    #__osma_chiamate_comunicazioni c 
                    LEFT OUTER JOIN #__users u ON u.id = c.idUtente
                    LEFT OUTER JOIN #__osma_preventivatore_preventivi p ON p.idChiamata = c.idChiamata
                WHERE c.idChiamata = " . $res->idChiamata . " 
                ORDER BY inserted DESC";

            $db->setQuery($query);
            $results[$key]->comunicazioni = $db->loadObjectList();

            $query = "
                SELECT  *
                FROM    #__osma_chiamata_interventi
                WHERE idChiamata = " . $res->idChiamata;
            $db->setQuery($query);
            $interventi = $db->loadObjectList();
            $results[$key]->interventi = $interventi;

            if ($results[$key]->interventi) {
                foreach ($results[$key]->interventi as $num => $intervento) {

                    $query = "
                        SELECT  d.id as idDuvri, r.idRapporto
                        FROM    #__osma_duvri d
                            LEFT OUTER JOIN #__osma_duvri_rapporto r ON r.idDuvri = d.id 
                        WHERE idIntervento = " . $intervento->idIntervento . "
                        ORDER BY d.id DESC
                        LIMIT 0,1";
                    $db->setQuery($query);
                    $obj = $db->loadObject();
                    if ($obj) {
                        $results[$key]->interventi[$num]->idDuvri = $obj->idDuvri;
                        $results[$key]->interventi[$num]->idRapporto = $obj->idRapporto;
                    }
                }
            }

            $results[$key]->teamLeader = $this->getTeamLeader($res->idChiamata);

            if ($results[$key]->interventi) {
                foreach ($results[$key]->interventi as $key2 => $int) {
                    $query = "
                        SELECT  *
                        FROM    #__osma_chiamata_interventi_files
                        WHERE   tipoFile = 1 AND idIntervento = " . $int->idIntervento . "
                        ORDER   BY idFile";
                    $db->setQuery($query);
                    $files = $db->loadObjectList();
                    if ($files) {
                        $results[$key]->interventi[$key2]->files[1] = $files;
                    }
                    $query = "
                        SELECT  *
                        FROM    #__osma_chiamata_interventi_files
                        WHERE   tipoFile = 2 AND idIntervento = " . $int->idIntervento . "
                        ORDER   BY idFile";

                    $db->setQuery($query);
                    $files = $db->loadObjectList();
                    if ($files) {
                        $results[$key]->interventi[$key2]->files[2] = $files;
                    }
                }
            }
        }

        return $results;
    }

    public function getTeamLeader($idChiamata) {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $users = array();

        $query->select("u.id, u.name")->from("#__osma_chiamata_interventi i")->innerJoin("#__users u ON u.id = i.idInviaMailA")->where("idChiamata = {$idChiamata}");

        $db->setQuery($query);
        foreach ($db->loadObjectList() as $user) {
            $users[] = "{$user->id}-{$user->name}";
        }

        return implode(";", array_unique($users));
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));
        $status = $db->escape($this->getState('filter.status'));
        $type = $db->escape($this->getState('filter.type'));
        $comune = $db->escape($this->getState('filter.comune'));
        $man = $db->escape($this->getState('filter.manutentore'));
        $data = $db->escape($this->getState('filter.data'));
        $scadute = $db->escape($this->getState('filter.scadute'));
        $incorso = $db->escape($this->getState('filter.incorso'));
        $tipoChiamata = $db->escape($this->getState('filter.tipoChiamata'));

        $daconsuntivare = 0;

        if ($status == 7) {
            $daconsuntivare = 1;
            $status = null;
        }

        $user = JFactory::getUser();
        $userid = $user->get('id');

        $query->select("DISTINCT c.*, ac.ragioneSociale AS cliente, ag.*, com.fascia, com.idCompagnia, com.compagniaColor, com.iconColor")
                ->from($db->qn("#__osma_chiamate") . ' AS c')
                ->leftJoin($db->qn("#__osma_chiamata_interventi") . ' AS inte ON inte.idChiamata = c.idChiamata')
                ->leftJoin($db->qn("#__osma_anagrafica_clienti") . ' AS ac ON ac.idCliente = c.idCliente')
                ->leftJoin($db->qn("#__osma_anagrafica_gestori") . ' AS ag ON ag.idGestore = c.idGestore')
                ->leftJoin($db->qn("#__osma_anagrafica_compagnie") . ' AS com ON com.idCompagnia = c.idCompagnia')
                ->order("c.dataApertura DESC");


        if (osmaHelper::isAccessLevel(COM_OSMA_AL_MANUTENTORI) && !osmaHelper::isManutentoreTest()) {
            $man = $userid;
        }

        if (osmaHelper::isAccessLevel(COM_OSMA_AL_UTENZE)) {
            if (osmaHelper::isGroup(COM_OSMA_GR_CLIENTI)) {
                $query->where("c.idCliente = " . osmaHelper::getUtenza('idCliente', 'cliente'));
            } elseif (osmaHelper::isGroup(COM_OSMA_GR_GESTORI)) {
                $query->where("c.idGestore = " . osmaHelper::getUtenza('idGestore', 'gestore'));
            }
        }

        if ($status && $status != 2 && !$incorso) {
            $query->where("c.stato = " . $status);
        } elseif ($status == 2 || $incorso) {
            $query->where("c.stato NOT IN (3, 4)");
        }

        if ($type) {
            $query->where("inte.idTipoIntervento = " . $type);
        }
        if ($tipoChiamata) {
            $query->where("c.tipo = " . $tipoChiamata);
        }
        if ($comune) {
            $query->where("ag.comune LIKE " . $db->q('%' . $db->escape($comune, true) . '%'));
        }
        if ($man) {
            /* $query->where("(" . $man . " IN (SELECT idUser FROM #__osma_xref_intervento_utenti u INNER JOIN #__osma_chiamata_interventi i ON i.idIntervento = u.idIntervento WHERE i.idChiamata = c.idChiamata) OR
              " . $man . " IN (SELECT idInviaMailA FROM #__osma_chiamata_interventi as i WHERE i.idChiamata = c.idChiamata))"); */
            $query->where("(c.idChiamata IN (SELECT idChiamata FROM #__osma_xref_intervento_utenti WHERE idUser = " . $db->quote($man) . ") OR c.idChiamata IN (SELECT idChiamata FROM #__osma_chiamata_interventi WHERE idInviaMailA = " . $db->quote($man) . "))");
        }
        if ($scadute) {
            $query->where("c.dataScadenza < NOW()")->where("stato != 4");
        }
        if ($daconsuntivare) {
            $query->where("c.consuntivata = 0");
            $query->where("c.tipo = 2");
        }

        if ($data) {
            $query->where("DATE_FORMAT( c.dataScadenza, '%d/%m/%Y' ) = '" . $data . "'");
        }
        if ($search) {
            $search = $db->Quote('%' . $db->escape($search, true) . '%');
            $query->where("(c.nrChiamata LIKE " . $search . " OR c.nrChiamataCompagnia LIKE " . $search . " OR ag.nrPuntoVendita LIKE " . $search . " OR ag.comune LIKE " . $search . " OR c.descrizioneGenerale LIKE " . $search . ")");
        }

        return $query;
    }

    function getGestori() {
        $db = JFactory::getDBO();
        $query = "SELECT idGestore, ragioneSociale FROM #__osma_anagrafica_gestori WHERE published=1 AND deleted=0 ORDER BY ragioneSociale ASC";
        $db->setQuery($query);
        $results = $db->loadObjectList();

        return $results;
    }

    function getComuni() {
        $db = JFactory::getDBO();
        $query = "SELECT DISTINCT comune FROM #__osma_anagrafica_gestori WHERE published=1 AND deleted=0 ORDER BY comune ASC";
        $db->setQuery($query);
        $results = $db->loadObjectList();

        return $results;
    }

    function getManutentori() {
        $db = JFactory::getDBO();
        $query = "SELECT idUser,name
              FROM #__users AS u
              RIGHT JOIN #__osma_anagrafica_manutentori AS am on am.idUser=u.id
              ORDER BY name ASC";
        $db->setQuery($query);
        $results = $db->loadObjectList();

        return $results;
    }

    function stampa() {
        $db = JFactory::getDBO();
        $idChiamata = JRequest::getVar('idChiamata');
        $query = "SELECT c.*,clienti.ragioneSociale,ac.compagnia,ac.fascia,ag.*,gc.riferimento,gc.telefono
              FROM #__osma_chiamate AS c
              LEFT JOIN #__osma_anagrafica_clienti AS clienti ON clienti.idCliente=c.idCliente
              LEFT JOIN #__osma_anagrafica_compagnie AS ac ON c.idCompagnia=ac.idCompagnia
              LEFT JOIN #__osma_anagrafica_gestori AS ag ON c.idGestore=ag.idGestore
              LEFT JOIN #__osma_gestori_contatti AS gc ON c.idGestore=gc.idGestore
              WHERE c.idChiamata=" . $idChiamata;
        $db->setQuery($query);
        $datiMail = $db->loadObject();

        if ($datiMail->stato == 1) {
            $s = "// A //";
            $mStato = "Aperta";
        } elseif ($datiMail->stato == 2) {
            $s = "// I //";
            $mStato = "In Corso";
        } elseif ($datiMail->stato == 3) {
            $s = "// S //";
            $mStato = "Sospesa";
        } elseif ($datiMail->stato == 4) {
            $s = "// C //";
            $mStato = "Chiusa";
        }

        if ($datiMail->tipo == 1) {
            $mTipo = "Forfait";
        } elseif ($datiMail->tipo == 2) {
            $mTipo = "Extra Forfait";
        } elseif ($datiMail->tipo == 3) {
            $mTipo = "Programmate";
        } elseif ($datiMail->tipo == 4) {
            $mTipo = "Giroluci";
        } elseif ($datiMail->tipo == 5) {
            $mTipo = "Presa Visione";
        }

        if ($datiMail->canale == 1) {
            $mCanale = "Mail";
        } elseif ($datiMail->canale == 2) {
            $mCanale = "Telefono";
        } elseif ($datiMail->canale == 3) {
            $mCanale = "Portale Compagnia";
        } elseif ($datiMail->canale == 4) {
            $mCanale = "Commessa";
        }

        //interventi
        $query = "SELECT ci.*,u.name
             FROM #__osma_chiamata_interventi as ci
             LEFT JOIN #__users AS u ON u.id=ci.idInviaMailA
             WHERE ci.idChiamata=" . $idChiamata;
        $db->setQuery($query);
        $interventi = $db->loadObjectList();

        $body = "<strong>" . $datiMail->ragioneSociale . "</strong><br />";
        $body .= "<p>Vi informiamo che sul sitema GISOne &egrave; stata assegnata una nuova chiamata " . strtoupper($mTipo) . " alla vs. ditta.</p>";
        $body .= "<hr><br />";
        $body .= "<p><strong>Numero di chiamata:</strong>" . $datiMail->nrChiamata . ($datiMail->nrChiamataCompagnia ? " - " . $datiMail->nrChiamataCompagnia : "") . "</p>";
        $body .= "<p><strong>Compagnia:</strong>" . $datiMail->compagnia . "</p>";
        $body .= "<p><strong>Codice Compagnia:</strong>" . $datiMail->nrChiamataCompagnia . "</p>";
        $body .= "<p><strong>Impianto:</strong>" . $datiMail->nrPuntoVendita . "</p>";
        $body .= "<p><strong>Dati Impianto:</strong>" . $datiMail->indirizzo . " " . $datiMail->comune . " (" . $datiMail->provincia . ")</p>";
        $body .= "<p><strong>Gruppo:</strong>" . $datiMail->fascia . "</p>";
        $body .= "<p><strong>Gestore:</strong>" . $datiMail->riferimento . "</p>";
        $body .= "<p><strong>Telefono:</strong>" . $datiMail->telefono . "</p>";
        $body .= "<p><strong>Data/Ora Chiamata:</strong>" . date("d/m/Y H:i", strtotime($datiMail->dataApertura)) . "</p>";
        $body .= "<p><strong>Data/Ora Scadenza:</strong>" . date("d/m/Y H:i", strtotime($datiMail->dataScadenza)) . "</p>";
        $body .= "<p><strong>Stato:</strong>" . $mStato . "</p>";
        $body .= "<p><strong>Provenienza:</strong>" . $mCanale . "</p>";
        $body .= "<p><strong>Descrizione Generale:</strong>" . $datiMail->descrizioneGenerale . "</p><p>&nbsp;</p>";
        $body .= "<hr>";
        $body .= "<strong>ELENCO INTERVENTI</strong>";
        $body .= "<hr>";
        foreach ($interventi as $key => $intervento) {
            if ($intervento->idTipoIntervento == 1) {
                $mTipoIntervento = "Meccanico";
            } elseif ($intervento->idTipoIntervento == 2) {
                $mTipoIntervento = "Edile";
            } elseif ($intervento->idTipoIntervento == 3) {
                $mTipoIntervento = "Elettrico";
            } elseif ($intervento->idTipoIntervento == 4) {
                $mTipoIntervento = "Elettronico";
            } elseif ($intervento->idTipoIntervento == 5) {
                $mTipoIntervento = "Video Sorveglianza";
            } elseif ($intervento->idTipoIntervento == 6) {
                $mTipoIntervento = "Antintrusione";
            }
            $body .= "<p><strong>Intervento Richiesto:</strong>" . $mTipoIntervento . "</p>";
            $body .= "<p><strong>Manutentore:</strong>" . $intervento->name . "</p>";
            if ($intervento->note && $intervento->note != "") {
                $body .= "<p><strong>Note Intervento:</strong>" . $intervento->note . "</p>";
            }
            $body .= "<hr>";
        }

        echo $body;
    }

}
