<?php

/**
 * @package     Joomla.Administrator
 * @subpackage  com_helloworld
 *
 * @copyright   Copyright (C) 2005 - 2016 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * HelloWorld Model
 *
 * @since  0.0.1
 */
class OsmaModelCompagnie extends JModelList {

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
        //Omit double (white-)spaces and set state
        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
        parent::populateState('ordering', 'ASC');
    }

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));

        if (empty($search)) {
            $query = "SELECT * FROM #__osma_anagrafica_compagnie WHERE deleted=0 ORDER BY compagnia ASC";
        } else {
            $search = $db->Quote('%' . $db->escape($search, true) . '%');

            $query = "SELECT * FROM #__osma_anagrafica_compagnie AS c
               WHERE c.deleted=0";
            $query .= " AND c.compagnia LIKE " . $search;
            $query .= " ORDER BY compagnia ASC";
        }

        return $query;
    }

    function pubblica() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::pubblica($ids, $type);

        return $return;
    }

    function sospendi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::sospendi($ids, $type);

        return $return;
    }

    function rimuovi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::rimuovi($ids, $type);

        return $return;
    }

    function salva() {
        $type = JRequest::getVar("type");
        $return = osmaHelper::salvaStrumenti($type);
        $idCompagnia = JRequest::getVar("id");
        $file = JRequest::getVar('subfile', null, 'files', 'array');

        //$return = var_dump($file);
        if ($file['tmp_name']) {
            //Import filesystem libraries. Perhaps not necessary, but does not hurt
            jimport('joomla.filesystem.file');
            //Clean up filename to get rid of strange characters like spaces etc
            $pic = $orig = $idCompagnia . ".jpg";
            //Set up the source and destination of the file

            $orig = JPATH_ROOT . DS . 'components' . DS . 'com_osma' . DS . "files" . DS . "compagnie" . DS . $orig;
            $pic = JPATH_ROOT . DS . 'components' . DS . 'com_osma' . DS . "files" . DS . "compagnie" . DS . $pic;

            $src = $file['tmp_name'];
            //First check if the file has the right extension, we need jpg only
            if (strtolower(JFile::getExt($file['name'])) == 'jpg') {
                if (JFile::upload($src, $orig)) {//upload immagine originale
                    //ridimensionamento immagine in proporzione
                    $new_w = 200;
                    $new_h = 150;
                    $rapp = $new_w / $new_h;
                    list($source_w, $source_h) = getimagesize($orig);
                    $sourcerapp = $source_w / $source_h;
                    $image = imagecreatefromjpeg($orig);


                    if ($source_w >= $source_h) {
                        if ($rapp >= $sourcerapp) {
                            $new_h = round(($new_w * $source_h) / $source_w);
                        } else {
                            $new_w = round(($new_h * $source_w) / $source_h);
                        }
                    } else {
                        $new_h = round(($new_w * $source_h) / $source_w);
                    }

                    $ridim = imagecreatetruecolor($new_w, $new_h);
                    imagecopyresampled($ridim, $image, 0, 0, 0, 0, $new_w, $new_h, $source_w, $source_h);
                    imagejpeg($ridim, $pic);

                    $return = "correct";
                } else {
                    //Redirect and throw an error message
                    $return = "error";
                }
            } else {
                $return = "format";
            }
        }
        echo $return;
    }

}
