<?php

defined('_JEXEC') or die('Restricted access');

class OsmaModelManutentori extends JModelList {

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
        //Omit double (white-)spaces and set state
        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
        $this->setState('filter.status', JRequest::getVar("filter_status"));
        parent::populateState('ordering', 'ASC');
    }

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->clear()->select("u.id AS idUser, u.name, u.email, m.telefono, m.costoOrario, m.scadenzaVisita, u.block")
                ->from("#__users as u")
                ->innerJoin("#__user_usergroup_map AS uum ON uum.user_id = u.id")
                ->innerJoin("#__usergroups AS g ON g.id = uum.group_id")
                ->innerJoin("#__osma_anagrafica_manutentori AS m ON u.id = m.idUser")
                ->where("LOWER(g.title) = 'manutentori'")
                ->order("u.name");

        $search = $db->quote("%" . $this->getState('filter.search') . "%");
        if ($search) {
            $query->where("(u.name LIKE " . $search . " OR u.email LIKE " . $search . " OR m.telefono LIKE " . $search . ")");
        }
        $status = $db->escape($this->getState('filter.status'));
        if ($status == 1) {
            $query->where("(u.block = 0)");
        } elseif ($status == 2) {
            $query->where("(u.block = 1)");
        } else {
            $query->where("(u.block = 0)");
        }

        return $query;
    }

    function addManutentoriForm() {
        $db = JFactory::getDBO();
        $type = 1;

        $idUser = JRequest::getVar("idUser");

        $query = " SELECT u.name, u.email, m.telefono, m.costoOrario, m.idMezzo, m.scadenzaVisita FROM #__users AS u LEFT JOIN #__osma_anagrafica_manutentori AS m ON u.id = m.idUser WHERE u.id = " . $idUser;

        $db->setQuery($query);
        $db->query();
        $data = $db->loadObject();

        //mezzi
        $query = "SELECT idMezzo,marca,modello,targa
              FROM #__osma_anagrafica_mezzi
              WHERE published=1 and deleted=0 ORDER BY modello ASC";
        $db->setQuery($query);
        $db->query();
        $mezzi = $db->loadObjectList();


        include('components/com_osma/templates/addmanutentore.php');
    }

    function pubblica() {
        $db = JFactory::getDBO();
        $ids = JRequest::getVar("ids");

        foreach ($ids AS $id) {
            $query = "UPDATE #__users SET block = 0 WHERE id = " . $id;
            $db->setQuery($query);
            $db->query();
        }

        return true;
    }

    function sospendi() {
        $db = JFactory::getDBO();
        $ids = JRequest::getVar("ids");

        foreach ($ids AS $id) {
            $query = "UPDATE #__users SET block = 1 WHERE id  =" . $id;
            $db->setQuery($query);
            $db->query();
        }

        return true;
    }

    function rimuovi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::rimuovi($ids, $type);

        return $return;
    }

    function salva() {
        $db = JFactory::getDBO();
        jimport('joomla.access.access');
        jimport('joomla.user.helper');

        $idUser = JRequest::getVar("idUser");

        $name = JRequest::getVar("name");
        $telefono = JRequest::getVar("telefono");
        $costoOrario = JRequest::getVar("costoOrario");
        $email = JRequest::getVar("email");
        $password = JRequest::getVar("password");
        $idMezzo = JRequest::getVar("idMezzo");
        $scadenzaVisita = JRequest::getVar("scadenzaVisita");
        if (!$scadenzaVisita) {
            $scadenzaVisita = date("d/m/Y");
        }
        list($d, $m, $y) = explode("/", $scadenzaVisita);
        if (!$email) {
            $email = JApplication::stringURLSafe($name) . "@osmasnc.it";
        }
        if (!$password) {
            $password = $name;
        }

        $data = new stdClass();
        $data->name = $name;
        $data->email = $email;
        $data->username = $email;
        $data->password = $password;

        $manut = new stdClass();
        $manut->telefono = $telefono;
        $manut->costoOrario = $costoOrario;
        $manut->idMezzo = $idMezzo;
        $manut->scadenzaVisita = "{$y}-{$m}-{$d}";

        if ($idUser == 0) {
            $idUser = $this->addNewJoomlaUser($data);
            $manut->idUser = $idUser;

            $db->insertObject('#__osma_anagrafica_manutentori', $manut, idManutentore);
            $result = $db->getErrorMsg();
        } else {
            $this->updateJoomlaUserData($data, $idUser);
            $manut->idUser = $idUser;

            $db->updateObject('#__osma_anagrafica_manutentori', $manut, idUser);
            $result = $db->getErrorMsg();
        }

        echo $idUser;
    }

    private function addNewJoomlaUser($data, $name) {

        $userData = array(
            "name" => $data->name,
            "username" => $data->username,
            "email" => $data->email,
            "password" => $data->password,
            "block" => 0,
            "groups" => array("14")
        );

        jimport('joomla.user.helper');
        $user = new JUser;
        if (!$user->bind($userData)) {
            throw new Exception("Impossibile caricare i dati dell'utente. Error: " . $user->getError());
        }
        if (!$user->save()) {
            throw new Exception("Impossibile salvare il nuovo utente. Error: " . $user->getError());
        }

        return $user->id;
    }

    public function updateJoomlaUserData($data, $id) {
        if ($data->password && $data->password != "") {
            $userData = array(
                "name" => $data->name,
                "username" => $data->username,
                "email" => $data->email,
                "password" => $data->password,
                "password2" => $data->password
            );
        } else {
            $userData = array(
                "name" => $data->name,
                "username" => $data->username,
                "email" => $data->email
            );
        }

        jimport('joomla.user.helper');
        $user = JFactory::getUser($id);

        if (!$user->bind($userData)) {
            throw new Exception("Impossibile caricare i dati dell'utente. Error: " . $user->getError());
        }
        if (!$user->save()) {
            throw new Exception("Impossibile salvare il nuovo utente. Error: " . $user->getError());
        }
        return true;
    }

}
