<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class OsmaModelMezzi extends JModelList {

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
        //Omit double (white-)spaces and set state
        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
        parent::populateState('ordering', 'ASC');
    }

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));

        $query->clear()->select("*")->from("#__osma_anagrafica_mezzi")->where("deleted = 0")->order("marca ASC");

        if ($search) {
            $search = $db->quote('%' . $db->escape($search, true) . '%');

            $query->where("(marca LIKE " . $search . " OR modello LIKE " . $search . " OR targa LIKE " . $search . ")");
        }

        return $query;
    }

    function addMezziForm() {
        $db = JFactory::getDBO();
        $type = 2;

        $idMezzo = JRequest::getVar("id");

        $query = "SELECT * FROM #__osma_anagrafica_mezzi WHERE idMezzo = " . $idMezzo;

        $db->setQuery($query);
        $db->query();
        $data = $db->loadObject();

        include('components/com_osma/templates/addmezzo.php');
    }

    function pubblica() {
        $ids = JRequest::getVar("ids");
        $db = JFactory::getDBO();

        foreach ($ids AS $idMezzo) {
            $query = "UPDATE #__osma_anagrafica_mezzi
      SET published=1
      WHERE idMezzo=" . $idMezzo;
            $db->setQuery($query);
            $db->query();
        }
        return true;
    }

    function sospendi() {
        $ids = JRequest::getVar("ids");
        $db = JFactory::getDBO();

        foreach ($ids AS $idMezzo) {
            $query = "UPDATE #__osma_anagrafica_mezzi
      SET published=0
      WHERE idMezzo=" . $idMezzo;
            $db->setQuery($query);
            $db->query();
        }
        return true;
    }

    function rimuovi() {
        $ids = JRequest::getVar("ids");
        $db = JFactory::getDBO();

        foreach ($ids AS $idMezzo) {
            $query = "UPDATE #__osma_anagrafica_mezzi
      SET deleted=1
      WHERE idMezzo=" . $idMezzo;
            $db->setQuery($query);
            $db->query();
        }
        return true;
    }

    function salva() {
        $db = JFactory::getDBO();

        $id = JRequest::getVar("id");

        $marca = JRequest::getVar("marca");
        $modello = JRequest::getVar("modello");
        $targa = JRequest::getVar("targa");
        $rimborsoACI = JRequest::getVar("rimborso");
        $scadenzaBollo = JRequest::getVar("scadenzaBollo");
        $scadenzaAssicurazione = JRequest::getVar("scadenzaAssicurazione");
        $scadenzaRevisione = JRequest::getVar("scadenzaRevisione");
        $note = JRequest::getVar("note");

        $data = new stdClass();
        $data->marca = $marca;
        $data->modello = $modello;
        $data->targa = $targa;
        $data->rimborsoACI = $rimborsoACI;

        if ($scadenzaBollo && $scadenzaBollo != "") {
            $data->scadenzaBollo = date("Y-m-d", strtotime(str_replace("/", "-", $scadenzaBollo)));
        } else {
            $data->scadenzaBollo = "0000-00-00";
        }

        if ($scadenzaAssicurazione && $scadenzaAssicurazione != "") {
            $data->scadenzaAssicurazione = date("Y-m-d", strtotime(str_replace("/", "-", $scadenzaAssicurazione)));
        } else {
            $data->scadenzaAssicurazione = "0000-00-00";
        }

        if ($scadenzaRevisione && $scadenzaRevisione != "") {
            $data->scadenzaRevisione = date("Y-m-d", strtotime(str_replace("/", "-", $scadenzaRevisione)));
        } else {
            $data->scadenzaRevisione = "0000-00-00";
        }

        $data->note = $note;
        $data->published = 1;
        $data->deleted = 0;

        if ($id) {
            //modifica
            $data->idMezzo = $id;
            $db->updateObject('#__osma_anagrafica_mezzi', $data, idMezzo);
            $result = $db->getErrorMsg();
        } else {
            $data->createDate = date('Y-m-d H:i:s');
            //salva
            $db->insertObject('#__osma_anagrafica_mezzi', $data, idMezzo);
            $id = $db->insertid();
            $result = $db->getErrorMsg();
        }

        echo $result;
    }

}
