<?php
defined('_JEXEC') or die('Restricted access');

if ($this->preventivo->voci) {
    $vociprev = $this->preventivo->voci;
} else {
    $min40 = 0;
    $mag40 = 0;
    foreach ($this->items as $pis) {
        if ($pis->portata <= 40) {
            $min40++;
        } else {
            $mag40++;
        }
    }

    if ($min40) {
        $obj = new stdClass;
        $obj->descrizione = 'Verifica periodica per pistole con portata inferiore a 40 L/Min';
        $obj->quantita = $min40;
        $obj->um = "nr";
        $obj->sconto = "0";
        $vociprev[] = $obj;
    }
    if ($mag40) {
        $obj = new stdClass;
        $obj->descrizione = 'Verifica periodica per pistole con portata superiore a 40 L/Min';
        $obj->quantita = $mag40;
        $obj->um = "nr";
        $obj->sconto = "0";
        $vociprev[] = $obj;
    }
}

if ($this->preventivo) {
    $pistole = $this->preventivo->pistole;
} else {
    $pistole = $this->items;
}
?>

<div>
    <form name='generaPreventivo' action='<?php echo osmaHelper::router("index.php?option=com_osma&task=amministrazione.generapreventivo") ?>' method="POST" >
        <div class="panel panel-default main-panel ">
            <div class="panel-heading">
                <h1>Lavorazione preventivo</h1>
            </div>
            <div class="panel-body">
                <div class="row">
                    <div class="col-sm-6">
                        <div class="row">
                            <h4 class='text-danger col-sm-8'>Destinazione</h4>
                            <div class="col-sm-4">
                                <?php if ($this->gestore) { ?>
                                    <select name="utenzaDestinazione" class="chosen-select" data-search="false">
                                        <option value="gestore" <?php echo ($this->preventivo->utenzaDestinazione == "gestore" || !$this->preventivo ? "selected" : null ) ?> data-ragionesociale="<?php echo $this->gestore->ragioneSociale ?>" data-indirizzo="<?php echo $this->gestore->indirizzo ?>" data-comune="<?php echo $this->gestore->comune ?>" data-cap="<?php echo str_pad($this->gestore->cap, 5, "0", STR_PAD_LEFT) ?>" data-telefono="<?php echo $this->gestore->telefono ?>">Utente metrico</option>
                                        <option value="cliente" <?php echo ($this->preventivo->utenzaDestinazione == "cliente" ? "selected" : null ) ?> data-ragionesociale="<?php echo $this->cliente->ragioneSociale ?>" data-indirizzo="<?php echo $this->cliente->indirizzo ?>" data-comune="<?php echo $this->cliente->comune ?>" data-cap="<?php echo str_pad($this->cliente->cap, 5, "0", STR_PAD_LEFT) ?>" data-telefono="<?php echo $this->cliente->telefono ?>">Cliente</option>
                                    </select>
                                <?php } ?>
                            </div>
                            <div class="col-sm-6">
                                <strong>Denominazione</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="destinazione[ragioneSociale]" value='<?php echo ($this->preventivo ? $this->destinazione->ragioneSociale : $this->gestore->ragioneSociale) ?>' style='width: 100%' />
                            </div>
                            <div class="col-sm-6">
                                <strong>Indirizzo</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="destinazione[indirizzo]" value='<?php echo ($this->preventivo ? $this->destinazione->indirizzo : $this->gestore->indirizzo) ?>' style='width: 100%' />
                            </div>
                            <div class="col-sm-6" style="margin-top: 15px">
                                <strong>Città</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="destinazione[comune]" value='<?php echo ($this->preventivo ? $this->destinazione->comune : $this->gestore->comune) ?>' style='width: 100%' />
                            </div>
                            <div class="col-sm-2" style="margin-top: 15px">
                                <strong>CAP</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="destinazione[cap]" value='<?php echo ($this->preventivo ? $this->destinazione->cap : $this->gestore->cap) ?>' style='width: 100%' />
                            </div>
                            <div class="col-sm-4" style="margin-top: 15px">
                                <strong>Telefono</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="destinazione[telefono]" value='<?php echo ($this->preventivo ? $this->destinazione->telefono : $this->gestore->telefono) ?>' style='width: 100%' />
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-6 bd-left">
                        <div class="row">
                            <h4 class='text-danger col-sm-8'>Spettabile</h4>
                            <div class="col-sm-4">
                                <?php if ($this->gestore) { ?>
                                    <select name="utenzaSpettabile" class="chosen-select" data-search="false">
                                        <option value="gestore" <?php echo ($this->preventivo->utenzaSpettabile == "gestore" ? "selected" : null ) ?> data-ragionesociale="<?php echo $this->gestore->ragioneSociale ?>" data-indirizzo="<?php echo $this->gestore->indirizzo ?>" data-comune="<?php echo $this->gestore->comune ?>" data-cap="<?php echo str_pad($this->gestore->cap, 5, "0", STR_PAD_LEFT) ?>" data-telefono="<?php echo $this->gestore->telefono ?>">Utente metrico</option>
                                        <option value="cliente" <?php echo ($this->preventivo->utenzaSpettabile == "cliente" || !$this->preventivo ? "selected" : null ) ?> data-ragionesociale="<?php echo $this->cliente->ragioneSociale ?>" data-indirizzo="<?php echo $this->cliente->indirizzo ?>" data-comune="<?php echo $this->cliente->comune ?>" data-cap="<?php echo str_pad($this->cliente->cap, 5, "0", STR_PAD_LEFT) ?>" data-telefono="<?php echo $this->cliente->telefono ?>">Cliente</option>
                                    </select>
                                <?php } ?>
                            </div>
                            <div class="col-sm-6">
                                <strong>Denominazione</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="spettabile[ragioneSociale]" value='<?php echo ($this->preventivo ? $this->spettabile->ragioneSociale : $this->cliente->ragioneSociale) ?>' style='width: 100%' />
                            </div>
                            <div class="col-sm-6">
                                <strong>Indirizzo</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="spettabile[indirizzo]" value='<?php echo ($this->preventivo ? $this->spettabile->indirizzo : $this->cliente->indirizzo) ?>' style='width: 100%' />
                            </div>
                            <div class="col-sm-6" style="margin-top: 15px">
                                <strong>Città</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="spettabile[comune]" value='<?php echo ($this->preventivo ? $this->spettabile->comune : $this->cliente->comune) ?>' style='width: 100%' />
                            </div>
                            <div class="col-sm-2" style="margin-top: 15px">
                                <strong>CAP</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="spettabile[cap]" value='<?php echo ($this->preventivo ? $this->spettabile->cap : $this->cliente->cap) ?>' style='width: 100%' />
                            </div>
                            <div class="col-sm-4" style="margin-top: 15px">
                                <strong>Telefono</strong>
                                <div class="clearfix"></div>
                                <input type="text" name="spettabile[telefono]" value='<?php echo ($this->preventivo ? $this->spettabile->telefono : $this->cliente->telefono) ?>' style='width: 100%' />
                            </div>
                        </div>
                    </div>
                </div>
                <hr/>
                <h4>Strumenti per cui è richiesta la verifica periodica</h4>
                <table class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th width="155" class="text-left">Codice</th>
                            <th width="">Descrizione</th>
                            <th width="115" class="text-center">U.M.</th>
                            <th width="140" class="text-right">Prezzo</th>
                            <th width="75" class="text-right">Q.tà</th>
                            <th width="140" class="text-right">Sconto</th>
                            <th width="150" class="text-right">Totale</th>
                            <th width="100" class="text-center">IVA</th>
                            <th width="10"></th>
                        </tr>
                    </thead>
                    <tfoot>
                        <tr>
                            <td colspan="9" class="text-right">
                                <a class="btn btn-success btn-sm row-add" href="javascript:void(0);">Aggiungi riga</a>
                            </td>
                        </tr>
                    </tfoot>
                    <tbody>
                        <?php if ($vociprev) { ?>
                            <?php foreach ($vociprev as $pi) { ?>
                                <tr>
                                    <td>
                                        <select name="rows[codice][]" class="chosen-select" data-placeholder="Seleziona codice" data-results="Premi invio per aggiungere">
                                            <option value=""></option>
                                            <?php foreach ($this->codiciMagazzino as $cod) { ?>
                                                <option value="<?php echo $cod->idCodice ?>" <?php echo ($pi->idCodice == $cod->idCodice ? "selected='selected'" : "") ?>><?php echo $cod->codice ?></option>
                                            <?php } ?>
                                        </select>
                                    </td>
                                    <td><input name="rows[descrizione][]" type="text" placeholder="Descrizione" value="<?php echo $pi->descrizione ?>" /></td>
                                    <td>
                                        <select name="rows[um][]" class="chosen-select" data-search="false" data-placeholder="Seleziona">
                                            <option value></option>
                                            <option value="nr" <?php echo ($pi->um == 'nr' ? 'selected' : null) ?>>NR.</option>
                                            <option value="pz" <?php echo ($pi->um == 'pz' ? 'selected' : null) ?>>PZ.</option>
                                        </select>
                                    </td>
                                    <td><div class="control-group has-icon"><input name="rows[prezzo][]" type="number" placeholder="" class="has-icon-left text-right" min="0" step="0.01"  value="<?php echo $pi->prezzo ?>"/><i class='fa fa-eur control-group-icon'></i></div></td>
                                    <td><input name="rows[quantita][]" type="number" placeholder="" min="1" step="1" value="<?php echo $pi->quantita ?>" class="text-right"/></td>
                                    <td><div class="control-group has-icon"><input name="rows[sconto][]" type="number" placeholder="" class="has-icon-left text-right" max="100" min="0" value="<?php echo $pi->sconto ?>"/><i class='fa fa-percent control-group-icon'></i></div></td>
                                    <td><div class="control-group has-icon"><input name="rows[totale][]" type="number" placeholder="" class="has-icon-left text-right" min="0" step="0.01" value="<?php echo $pi->totale ?>" readonly="readonly" /><i class='fa fa-eur control-group-icon'></i></div></td>
                                    <td>
                                        <select name="rows[iva][]" class="chosen-select" data-search="false">
                                            <option value="0">0</option>
                                            <option value="4">4%</option>
                                            <option value="10">10%</option>
                                            <option value="22" selected="selected">22%</option>
                                        </select>
                                    </td>
                                    <td class="text-center"><a href="javascript:void(0);" class="btn btn-sm btn-danger row-remove"><i class="fa fa-times"></i></a></td>
                                </tr>
                            <?php } ?>
                        <?php } else { ?>
                            <tr>
                                <td>
                                    <select name="rows[codice][]" class="chosen-select" data-placeholder="Seleziona codice" data-results="Premi invio per aggiungere">
                                        <option value=""></option>
                                        <?php foreach ($this->codiciMagazzino as $cod) { ?>
                                            <option value="<?php echo $cod->idCodice ?>"><?php echo $cod->codice ?></option>
                                        <?php } ?>
                                    </select>
                                </td>
                                <td><input name="rows[descrizione][]" type="text" placeholder="Descrizione" value="" /></td>
                                <td>
                                    <select name="rows[um][]" class="chosen-select" data-search="false" data-placeholder="Seleziona">
                                        <option value></option>
                                        <option value="nr" <?php echo ($pi->um == 'nr' ? 'selected' : null) ?>>NR.</option>
                                        <option value="pz" <?php echo ($pi->um == 'pz' ? 'selected' : null) ?>>PZ.</option>
                                    </select>
                                </td>
                                <td><div class="control-group has-icon"><input name="rows[prezzo][]" type="number" placeholder="" class="has-icon-left text-right" min="0" step="0.01" /><i class='fa fa-eur control-group-icon'></i></div></td>
                                <td><input name="rows[quantita][]" type="number" placeholder="" min="1" step="1" value="" class="text-right"/></td>
                                <td><div class="control-group has-icon"><input name="rows[sconto][]" type="number" placeholder="" class="has-icon-left text-right" max="100" min="0" value="0"/><i class='fa fa-percent control-group-icon'></i></div></td>
                                <td><div class="control-group has-icon"><input name="rows[totale][]" type="number" placeholder="" class="has-icon-left text-right" min="0" step="0.01" readonly="readonly" /><i class='fa fa-eur control-group-icon'></i></div></td>
                                <td>
                                    <select name="rows[iva][]" class="chosen-select" data-search="false">
                                        <option value="0">0</option>
                                        <option value="4">4%</option>
                                        <option value="10">10%</option>
                                        <option value="22" selected="selected">22%</option>
                                    </select>
                                </td>
                                <td class="text-center"><a href="javascript:void(0);" class="btn btn-sm btn-danger row-remove"><i class="fa fa-times"></i></a></td>
                            </tr>
                        <?php } ?>
                    </tbody>
                </table>
                <hr/>
                <div class="row" >
                    <div class="col-sm-3">
                        <strong>Tipo di pagamento</strong>
                        <div class="clearfix"></div>
                        <select name="tipoPagamento" class="chosen-select" data-search="false">
                            <option value='1' <?php echo ($this->preventivo->tipoPagamento == 1 ? "selected" : null) ?>>Bonifico anticipato</option>
                            <option value='2' <?php echo ($this->preventivo->tipoPagamento == 2 ? "selected" : null) ?>>Bonifico a 60 gg</option>
                            <option value='3' <?php echo ($this->preventivo->tipoPagamento == 3 ? "selected" : null) ?>>Bonifico a 90 gg</option>
                        </select>
                    </div>
                    <div class="col-sm-3">
                        <strong>Selezione banca</strong>
                        <div class="clearfix"></div>
                        <select name="banca" class="chosen-select" data-placeholder="Seleziona banca">
                            <option value=""></option>
                            <?php if ($this->banche) { ?>
                                <?php foreach ($this->banche as $banca) { ?>
                                    <option value="<?php echo $banca->idBanca ?>" <?php echo ($this->preventivo->idBanca == $banca->idBanca ? "selected" : null) ?>><?php echo $banca->denominazione ?></option>
                                <?php } ?>
                            <?php } ?>
                            <option value="new">Aggiungi nuova banca</option>
                        </select>
                    </div>
                    <div class="col-sm-6">
                        <div class="row">
                            <div class="col-sm-4">
                                <strong>Totale imponibile</strong>
                                <div class="clearfix"></div>
                                <div class="control-group has-icon"><input name="totaleImponibile" type="text" class="has-icon-left text-right" readonly="readonly" value="<?php echo $this->preventivo->totaleImponibile ?>" /><i class='fa fa-eur control-group-icon'></i></div>
                            </div>
                            <div class="col-sm-4">
                                <strong>Totale I.V.A.</strong>
                                <div class="clearfix"></div>
                                <div class="control-group has-icon"><input name="totaleIva" type="text" class="has-icon-left text-right" readonly="readonly"  value="<?php echo $this->preventivo->totaleIva ?>" /><i class='fa fa-eur control-group-icon'></i></div>
                            </div>
                            <div class="col-sm-4">
                                <strong>Totale preventivo</strong>
                                <div class="clearfix"></div>
                                <div class="control-group has-icon"><input name="totalePreventivo" type="text" class="has-icon-left text-right" readonly="readonly"  value="<?php echo $this->preventivo->totalePreventivo ?>" /><i class='fa fa-eur control-group-icon'></i></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="panel-footer">
                <div class="clearfix">
                    <?php foreach ($pistole as $pistola) { ?>
                        <input type="hidden" name="idPistole[]" value="<?php echo $pistola->idPistola ?>"/>
                    <?php } ?>
                    <input type="hidden" name="idGestore" value="<?php echo ($this->preventivo ? $this->preventivo->idGestore : $this->gestore->idGestore) ?>"/>
                    <input type="hidden" name="idCliente" value="<?php echo ($this->preventivo ? $this->preventivo->idCliente : $this->cliente->idCliente) ?>"/>
                    <input type="hidden" name="idPreventivo" value="<?php echo $this->preventivo->idPreventivo ?>"/>
                    <button class="btn btn-success pull-right genera-preventivo" data-loading-text="<i class='fa fa-circle-o-notch fa-spin '></i> Generazione in corso">Salva preventivo</button
                </div>
            </div>
        </div>
        <style>
            input:not([type='submit']), select {width: 100%!important}
            div > strong {display: block; margin-bottom: 5px}
            .chosen-container {min-height: 30px!important; height: 30px!important;}
            .chosen-container .chosen-single {height: 100%;}
        </style>
        <script>
            jQuery(function ($) {
                $(document).on("change", "[name='rows[sconto][]'], [name='rows[prezzo][]']", function () {
                    if ($(this).val()) {
                        $(this).val($(this).val().replace(/,/g, "."));
                    }
                });
                $(document).on("change", "[name='rows[sconto][]'], [name='rows[prezzo][]'], [name='rows[quantita][]'], [name='rows[iva][]']", function () {
                    var __row = $(this).parents("tr");
                    if (!$(__row).find("[name='rows[prezzo][]']").val() || !$(__row).find("[name='rows[quantita][]']").val()) {
                        return;
                    }
                    var __val = parseFloat($(__row).find("[name='rows[prezzo][]']").val()) * parseInt($(__row).find("[name='rows[quantita][]']").val());
                    if (parseFloat($(__row).find("[name='rows[sconto][]']").val())) {
                        __val = __val - ((__val / 100) * parseFloat($(__row).find("[name='rows[sconto][]']").val()));
                    }

                    $(__row).find("[name='rows[totale][]']").val(Math.round(parseFloat(__val) * 100) / 100);

                    aggiornaTotali();
                });

                function aggiornaTotali() {
                    var __imp = 0, __iva = 0;
                    $("[name='rows[totale][]']").each(function () {
                        if (parseFloat($(this).val())) {
                            __imp += parseFloat($(this).val());

                            if (parseInt($(this).parents("tr").find("[name='rows[iva][]']").val()) > 0) {
                                var iva = parseInt($(this).parents("tr").find("[name='rows[iva][]']").val());
                                __iva += (parseFloat($(this).val()) / 100) * iva;
                            }
                        }
                    });

                    $("[name='totaleImponibile']").val(Math.round(parseFloat(__imp) * 100) / 100);
                    $("[name='totaleIva']").val(Math.round(parseFloat(__iva) * 100) / 100);
                    $("[name='totalePreventivo']").val(Math.round(parseFloat(__iva + __imp) * 100) / 100);
                }
                $(document).on("change", "[name='utenzaDestinazione']", function () {
                    $("[name='destinazione[ragioneSociale]']").val($(this).find("option:selected").data("ragionesociale"));
                    $("[name='destinazione[indirizzo]']").val($(this).find("option:selected").data("indirizzo"));
                    $("[name='destinazione[comune]']").val($(this).find("option:selected").data("comune"));
                    $("[name='destinazione[cap]']").val($(this).find("option:selected").data("cap"));
                    $("[name='destinazione[telefono]']").val($(this).find("option:selected").data("telefono"));
                });
                $(document).on("change", "[name='utenzaSpettabile']", function () {
                    $("[name='spettabile[ragioneSociale]']").val($(this).find("option:selected").data("ragionesociale"));
                    $("[name='spettabile[indirizzo]']").val($(this).find("option:selected").data("indirizzo"));
                    $("[name='spettabile[comune]']").val($(this).find("option:selected").data("comune"));
                    $("[name='spettabile[cap]']").val($(this).find("option:selected").data("cap"));
                    $("[name='spettabile[telefono]']").val($(this).find("option:selected").data("telefono"));
                });
                $(document).on("click", ".row-remove", function (e) {
                    e.stopPropagation();
                    e.stopImmediatePropagation();
                    $(this).parents("tr").remove();

                    aggiornaTotali();
                });
                $(document).on("click", ".row-add", function (e) {
                    e.stopPropagation();
                    e.stopImmediatePropagation();
                    var __row = $(this).parents("form").find("table tbody tr:last-of-type").clone();
                    $(__row).find("[name='rows[sconto][]'], [name='rows[iva][]']").val("0");
                    $(__row).find("[name='rows[quantita][]']").val("1");
                    $(__row).find("[name='rows[totale][]'], [name='rows[prezzo][]'], [name='rows[codice][]'], [name='rows[um][]'], [name='rows[descrizione][]']").val("");
                    $(__row).find(".chosen-container").remove();
                    $(__row).find(".chosen-select").each(function () {
                        var options = {
                            disable_search: false,
                            no_results_text: "Nessun risultato per"
                        };
                        if ($(this).data("search") === false) {
                            options.disable_search = true;
                        }
                        if ($(this).data("placeholder")) {
                            options.placeholder_text_single = $(this).data("placeholder");
                        }
                        if ($(this).data("results")) {
                            options.no_results_text = $(this).data("results");
                        }
                        $(this).chosen(options);
                    });
                    $(this).parents("form").find("table").append(__row);

                    aggiornaTotali();
                });

                $(".chosen-select").each(function () {
                    var options = {
                        disable_search: false,
                        no_results_text: "Nessun risultato per"
                    };
                    if ($(this).data("search") === false) {
                        options.disable_search = true;
                    }
                    if ($(this).data("placeholder")) {
                        options.placeholder_text_single = $(this).data("placeholder");
                    }
                    if ($(this).data("results")) {
                        options.no_results_text = $(this).data("results");
                    }
                    $(this).chosen(options);
                });

                $(document).on("keydown", ".chosen-container input", function (e) {
                    if ($(this).parents(".chosen-container").siblings("select").attr("name") !== "rows[codice][]") {
                        return;
                    }
                    if (e.keyCode === 13) {
                        var _select = $(this).parents(".chosen-container").siblings("select");
                        $(_select).append("<option value='new-" + $(this).val() + "' selected>" + $(this).val() + "</option>");
                        $(_select).trigger('chosen:updated');
                    }
                });

                $(document).on("change", "[name='banca']", function () {
                    if ($(this).val() == 'new') {
                        $('.modal.banca').modal();
                    }
                });

                $(document).on("change", "form[name='anagraficaBanca'] input", function () {
                    if ($(this).parents("form").find("[name='denominazione']").val() && $(this).parents("form").find("[name='intestazione']").val() && $(this).parents("form").find("[name='iban']").val()) {
                        $(".modal.banca .submit").removeClass("disabled");
                    } else {
                        $(".modal.banca .submit").addClass("disabled");
                    }
                });
                $(document).on("click", ".modal.banca .submit:not(.disabled)", function () {
                    var $this = $(this);
                    $this.button('loading').addClass("disabled");
                    $.ajax({
                        url: "index.php?option=com_osma&task=amministrazione.aggiungiBanca&format=raw",
                        data: $("form[name='anagraficaBanca']").serialize()
                    }).done(function (response) {
                        response = JSON.parse(response);
                        if (response.success) {
                            $("[name='banca']").append(response.data.option);
                            $("[name='banca']").trigger('chosen:updated');
                            $this.button('reset').removeClass("disabled");
                            $('.modal.banca').modal('hide');
                        }
                    });
                });

                $(document).on("click", ".genera-preventivo", function (e) {
                    e.stopImmediatePropagation();
                    e.stopPropagation();
                    var $this = $(this);
                    $this.button('loading').addClass("disabled");

                    $.ajax({
                        url: "index.php?option=com_osma&task=amministrazione.generaPreventivo&format=raw",
                        data: $("form[name='generaPreventivo']").serialize(),
                        method: 'POST'
                    }).done(function (response) {
                        response = JSON.parse(response);
                        if (!response.success) {
                            Joomla.renderMessages({
                                error: [response.message]
                            });
                            $this.button('reset').removeClass("disabled");
                        } else {
                            window.location = '<?php echo osmaHelper::router("index.php?option=com_osma&view=amministrazione&layout=elenco-preventivi") ?>';
                        }
                    });
                    return false;
                });
            });
        </script>
    </form>

    <div class="modal fade banca" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title">Aggiungi nuova sede bancaria</h4>
                </div>
                <div class="modal-body">
                    <form name="anagraficaBanca" method="POST" action="index.php">
                        <div class="row">
                            <div class="col-sm-12" style="margin-bottom: 15px;">
                                <input type="text" name="denominazione" placeholder="Denominazione" />
                            </div>
                            <div class="col-sm-6">
                                <input type="text" name="intestazione" placeholder="Intestazione" />
                            </div>
                            <div class="col-sm-6">
                                <input type="text" name="iban" placeholder="IBAN" />
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Chiudi</button>
                    <button type="button" class="btn btn-primary disabled submit" data-loading-text="<i class='fa fa-circle-o-notch fa-spin '></i> Salvo">Salva</button>
                </div>
            </div>
        </div
    </div>
</div>